#ifndef DIALOG_PARAMETERS_H
#define DIALOG_PARAMETERS_H

#include "ui_dialog_parameters.h"

class Dialog_Parameters : public QDialog, private Ui::Dialog_Parameters
{
    Q_OBJECT

public:
    explicit Dialog_Parameters(QWidget *parent = 0);

    int iUpperRotationQuantumNumberIndex ;
    int iLowerRotationQuantumNumberIndex ;
    void InitDialog() ;
    void InitPredictionFormatEditor() ;


private slots:
    void on_lineEdit_IntensityMultyplifier_textChanged(QString );
    void on_spinBox_LowerEnergyColumn_valueChanged(int );
    void on_pushButton_SetDefaultsPredictionDescription_clicked();
    void on_spinBox_UpperVibrationStateNameColumn_valueChanged(int );
    void on_spinBox_LowerVibrationStateNameColumn_valueChanged(int );
    void on_spinBox_LowerRotationStatePartColumn_valueChanged(int );
    void on_spinBox_LowerRotationQuantumNumberIndex_valueChanged(int );
    void on_spinBox_UpperRotationStatePartColumn_valueChanged(int );
    void on_spinBox_UpperRotationQuantumNumberIndex_valueChanged(int );
    void on_spinBox_RotationQuantumNumberQuantity_valueChanged(int );
    void on_spinBox_LineIntensityColumn_valueChanged(int );
    void on_spinBox_LineFrequensyColumn_valueChanged(QString );
    void on_pushButton_CreateIdentificationBase_clicked();
    void on_pushButton_CreadeLevelsBase_clicked();
    void on_Dialog_Parameters_rejected();
    void on_Dialog_Parameters_finished(int result);
    void on_toolButton_RecofnitionFileSelect_clicked();
    void on_toolButton_UpperStateBaseSelection_clicked();
    void on_toolButton_DipMomentSelect_clicked();
    void on_toolButton_LowStateFileSelect_clicked();
    void on_toolButton_UpperStateFileSelect_clicked();
    void on_toolButton_SpectrumSelect_clicked();
    void on_buttonBox_Parameters_accepted();
    void on_toolButton_IdentificationBaseSelection_clicked();


};

#endif // DIALOG_PARAMETERS_H
