#include <math.h>
#include <stdio.h>
//#include <conio.h>


#include <string.h>
#include <stdlib.h>



#define EXTERN
#include "glob_var.h"


#include "iodb.h"

#include "search.hpp"
#include "rec_proc.hpp"


#include <QProcess>
#include <QMessageBox>

int InitEnergyBankForReadOnly() ;
int InitEnergyBankForModify() ;



int getJfromN( int iCurrentRotationState )
{
    switch(WorkSpace.iSymType)
    {
    case MOLECULE_TYPE_C2V:
    case MOLECULE_TYPE_CS:    return (int)(sqrt(1.0*(iCurrentRotationState)));
        default: ;
    }

    return 0 ;
}



int getStartNfromJ( int j )
{
    switch(WorkSpace.iSymType)
    {
    case MOLECULE_TYPE_C2V:
    case MOLECULE_TYPE_CS:    return j*j ;
        default: ;
    }

    return 0 ;
}


int getEndNfromJ( int j )
{
    switch(WorkSpace.iSymType)
    {
    case MOLECULE_TYPE_C2V:
    case MOLECULE_TYPE_CS:    return j*j + 2*j ;
        default: ;
    }

    return 0 ;
}



void getupperstate(int number_of_level_abs,char *upper)
{ int i,j,ka,kc,tau,old_number_of_levels;

    old_number_of_levels_for_J = number_of_levels_for_J ;

    switch(WorkSpace.iSymType)
    {
    case MOLECULE_TYPE_C2V:
    case MOLECULE_TYPE_CS:  j=(int)(sqrt(1.0*(number_of_level_abs)));
         tau=number_of_level_abs-j*j-j;
         i=j+tau+1;    ka=(int)(i/2);    kc=ka-tau;
         if( j==0 ) { ka=0;  kc=0;  }       number_of_level_for_J = j + tau;
         sprintf(upper,"%2d%3d%3d",j,ka,kc);  number_of_levels_for_J = 2*j+1;
         if( number_of_levels_for_J != old_number_of_levels_for_J ) iCalcIsNesessary = 1;
         break;
    }
}




//     NUMBER of LEVEL  for defferent types of moleculs
int record_number(char *lev)
{ int j,ka,kc,tau;
switch(WorkSpace.iSymType){
case 0:
case 1: sscanf(lev,"%d%d%d",&j,&ka,&kc); tau=ka-kc; return j*j+j+tau; break;
                }
//cprintf(" BAD KWANTUM NUMBERS "); getch();
return -1;
}




void GetLevelText(char *buffer)
{
       /*use(winLevBank);
       clrscr();*/
       buffer[0] =  0 ;
       if(level.Energy>0)
       {
            sprintf(buffer, " %6s  %12.4f%6.2f%4d  %s",VibStateNames[WorkSpace.Iv-1],
                 level.Energy,level.RMS,level.Nlines,level.Note);
       }
}




int ReadBankLevel(int V,int number_of_level_abs)
{

    //if (  (eee=fopen(name[5],"rb")) !=NULL)
    if(fp_EnergyBank)
    {
        //read(fileno(eee),&lhead,sizeof(lhead));
        if( (V>=0)&&(V<=100) )
        {
            level.Energy=0;
            int i = ReadLevel(fp_EnergyBank, WorkSpace.iCurrentRotationState, &level, lhead, V ) ;
            if( i != -1)
               GetLevelText(cBaseEnergyInfo) ;
        }
        else
        { /*msg(10,10, "Error on read DataBank for levels",
             Col[0],Col[1],(Color)12,Col[5],1); */
        }

     //   fclose(eee);
    }

    return 0;
}



int number(double nu,float dnu,int *f)
{    int i,step;
     *f=0;
if(nu<dFrequensy[0] ) return 0;
if(nu>dFrequensy[nlinsp-1]) return nlinsp-1;

step=nlinsp/2;  i=0;

while(step!=0)
 {
  if( dFrequensy[i] > nu ) i-=step; else i+=step;
  step/=2;
 }
while( dFrequensy[i]>nu ) i--;
while( dFrequensy[i]<nu ) i++;
if( fabs(dFrequensy[i-1]-nu) < fabs(dFrequensy[i]-nu) ) i--;
if(  fabs(dFrequensy[i]-nu) < dnu  ) *f=1 ;
return i ;
}  /*number1*/






/*
-------------------------------------------------------------------
                                                                  
  Start calculation of combination differences                    
                                                                  
L-------------------------------------------------------------------
*/



#ifdef PLATFORM_WINDOWS
    #include <process.h>
#endif


int calc()
{
    char Av[100] ;
    int iTmp1 ;
    void SaveInit() ;
//void far flc_c2v(char *aArg1,char *aArg2);


    SaveInit() ;

    if(WorkSpace.iUsePrediction!=1)
    {
        if( iFlagCalcIsNecessary==0) return -2;

#ifdef PLATFORM_WINDOWS

        sprintf(Av,"%d",  WorkSpace.Iv );
        iTmp1 = spawnlp( P_WAIT, calcname[WorkSpace.iSymType], "0", Av, UpperRotationStateName, NULL ) ;
#endif

#ifdef PLATFORM_LINUX

        sprintf( calcname[WorkSpace.iSymType], "/home/sap/Projects/QSLON/qtsdk-slon/qslon-build-desktop/flcalc57") ;
        sprintf(Av,"%s %d %s", calcname[WorkSpace.iSymType], WorkSpace.Iv, UpperRotationStateName);
        /*QProcess process;
        process.start(Av);*/
        system(Av) ;
#endif

//process.start("del", QStringList() << "/s" << "*.txt");
//        printf("DLL:\n");
//        flc_c2v(Av,upper);
//        printf("OK\n");
//        getch();
        if( iTmp1==-1)
        {
            //printf("Calc : Error %d ",errno);
            //getch();
        }
        else  iFlagCalcIsNecessary = 0 ;
    }
    else
    {

#ifdef PLATFORM_LINUX

//        if( iFlagCalcIsNecessary == 0 ) return -2;
//        sprintf(Av,"%s %d %s", calcname[WorkSpace.iSymType], WorkSpace.Iv, UpperRotationStateName);
//        QProcess process;
//        process.start(Av);
#endif

#ifdef PLATFORM_WINDOWS
//        iTmp1 = spawnlp( P_WAIT, "takepred.exe", "0", Av, UpperRotationStateName,NULL);
//        printf("DLL:\n");
//        flc_c2v(Av,upper);
//        printf("OK\n");
//        getch();
#endif
        if( iTmp1 == -1 )
        {
            //printf("Calc : Error %d ",errno);
            //getch();
        }
        else  iFlagCalcIsNecessary = 0 ;
    }

return 0;
}


#ifdef PLATFORM_WINDOWS
    #include <process.h>
#endif

void CallEditText( char *cReportName)
{
    char Abuff[512];

    //sprintf(Abuff,"notepad %s", cReportName ) ;
#ifdef PLATFORM_WINDOWS
    spawnlp( P_NOWAIT, "notepad", "0", cReportName, NULL ) ;
#endif

#ifdef PLATFORM_LINUX
    sprintf(Abuff,"kwrite %s", cReportName ) ;
    /*QProcess process;
    process.start(Abuff);*/
    int i = system(Abuff) ;
    if( i !=0 )
    {
        void ErrorMessage(char  *Abuff) ;

        sprintf(Abuff,"Cannot start program 'kwrite'.\nPlease install this program.\nBut report written to '%s'\n", cReportName) ;
        ErrorMessage(Abuff) ;
    }
#endif
}



/*
-------------------------------------------------------------------
                                                                  
  Predictio file processing of combination differences                    
                                                                  
L-------------------------------------------------------------------
*/


int  PredictionFileProcessing( char *RotationStateName)
{
    FILE *fp ;
    char cPredictionName[256], Abuff[512] ;
    char cBuffer[20][40], *cPtr, *cPtr_dest ;
    int i, l, iWordStart , iWordsCount ;
    char RotationStatePartName[10][10] ;



    iWordsCount = 0 ;
    iWordStart = 0 ;

    cPtr = RotationStateName ;
    l = strlen(RotationStateName) ;
    i = 0 ;
    while(i<l)
    {
        while( ((*cPtr == ' ') || (*cPtr <= 15)) && (i<l) )
        {
            cPtr++ ;
            i++ ;
            iWordStart = 0 ;
        }
        while( ((*cPtr != ' ') && (*cPtr > 15)) && (i<l) )
        {
            if( iWordStart == 0 )
            {
                cPtr_dest = RotationStatePartName[iWordsCount] ;
                iWordsCount++ ;
            }
            *cPtr_dest++ = *cPtr++ ;
            *cPtr_dest = 0x0 ;

            i++ ;
            iWordStart = 1 ;
        }
    }


    ncd = 0 ;

    if(iWordsCount<WorkSpace.PreditionDescroption.iPrediction_RotationState_ColumnsNumber)  return -1 ;


    strcpy( cPredictionName, WorkSpace.name[DEF_UPPER_STATE_PAR_INDEX] ) ;
    l = strlen(cPredictionName) ;
    i = l-1 ;
    while( (i>0) && (cPredictionName[i]!='.') ) i-- ;

    if(i>0)  cPredictionName[i] = 0x0 ;

    strcat( cPredictionName,".dat") ;


    fp = fopen( cPredictionName, "rb" ) ;

    if( fp == NULL ) return -1 ;


    while( feof(fp) == 0 )
    {
        fgets(Abuff,512,fp) ;
        iWordsCount = 0 ;
        char *cPtr = Abuff ;
        int i,l ;

        /*do{
            cBuffer[iWordsCount][0] = 0x0 ;
            i = sscanf( cPtr,"%s", cBuffer[iWordsCount]) ;
            l = strlen(cBuffer[iWordsCount]) ;
            if( l > 0 )
            {
                cPtr = &cPtr[l];
                iWordsCount++ ;
            }
        }while( (iWordsCount<40)&&(l>0) ) ;*/

        iWordStart = 0 ;
        cPtr = Abuff ;
        l = strlen(Abuff) ;
        i = 0 ;
        while( i<l )
        {
            while( ((*cPtr == ' ') || (*cPtr <= 15)) && (i<l) )
            {
                cPtr++ ;
                i++ ;
                if( iWordStart == 1 ) iWordsCount++ ;
                iWordStart = 0 ;
            }
            while( ((*cPtr != ' ') && (*cPtr > 15)) && (i<l) )
            {
                if( iWordStart == 0 )
                {
                    cPtr_dest = cBuffer[iWordsCount] ;
                    //iWordsCount++ ;
                }
                *cPtr_dest++ = *cPtr++ ;
                *cPtr_dest = 0x0 ;

                i++ ;
                iWordStart = 1 ;
            }
        }

        int iFlagStopCompare = 0 ;

        if( ( iFlagStopCompare==0 ) && ( iWordsCount >= WorkSpace.PreditionDescroption.iPrediction_UpperVibState_Column ) )
        {

            if( strcmp( cBuffer[WorkSpace.PreditionDescroption.iPrediction_UpperVibState_Column], VibStateNames[WorkSpace.Iv-1] ) != 0 ) iFlagStopCompare = 1 ;

        }
        for(i=0;i<WorkSpace.PreditionDescroption.iPrediction_RotationState_ColumnsNumber;i++)
        {
            if( ( iFlagStopCompare==0 ) && ( iWordsCount >= WorkSpace.PreditionDescroption.iPrediction_UpperRotationState_Column[i] ) )
            {
                if( strcmp( cBuffer[WorkSpace.PreditionDescroption.iPrediction_UpperRotationState_Column[i]], RotationStatePartName[i] ) != 0 ) iFlagStopCompare = 1 ;
            }
        }

        if(iFlagStopCompare==0)
        {
            nucalc[ncd] = atof(cBuffer[WorkSpace.PreditionDescroption.iPrediction_Frequensy_Column]) ;
            eclow[ncd] = atof(cBuffer[WorkSpace.PreditionDescroption.iPrediction_LowerEnergyLevels_Column]) ;
            scalc[ncd] = atof(cBuffer[WorkSpace.PreditionDescroption.iPrediction_Intensity_Column]) ;
            scalc[ncd]*= WorkSpace.PreditionDescroption.dIntensityFactor ;
            strcpy( LowVibName[ncd] , cBuffer[WorkSpace.PreditionDescroption.iPrediction_LowerVibState_Column] ) ;
            ground[ncd][0] = 0x0 ;
            for(i=0;i<WorkSpace.PreditionDescroption.iPrediction_RotationState_ColumnsNumber;i++)
            {
                strcat( ground[ncd], cBuffer[WorkSpace.PreditionDescroption.iPrediction_LowerRotationState_Column[i]] ) ;
                if( i != ( WorkSpace.PreditionDescroption.iPrediction_RotationState_ColumnsNumber - 1 ) ) strcat( ground[ncd], " " ) ;
            }
            ecu = nucalc[ncd] + eclow[ncd] ;

            ncd++ ;
        }
    }

    fclose(fp) ;
}



/*
-------------------------------------------------------------------
                                                                  
  Start search of combination differences                         
                                                                  
L-------------------------------------------------------------------
*/


int search_lines(int search_mode, double E )
{
    int i1 ;

    if( WorkSpace.iUsePrediction == 1 )
    {
        //PredictionFileProcessing() ;
    }
    else
    {

        FILE *fp_combdiff ;

        fp_combdiff = fopen("dif.tmp","rt");

        if( fp_combdiff == NULL ) return 0;

        int number_of_level = WorkSpace.iCurrentRotationState - getStartNfromJ( WorkSpace.iCurrentJ ) ;

        int diffsize=sizeof(state_cont)+sizeof(ROTATION_STATE_NAME_TYPE)+
                      sizeof( number_of_levels_for_J)+
                      sizeof(ecu)+sizeof(ncd)+sizeof(ground)+
                      sizeof(nucalc)+sizeof(scalc)+sizeof(eclow);

        long pos;

        char br[64],br1[64], bstrength[64] ;


        int getStartNfromJ( int j ) ;


        for(i1=0;i1<=number_of_level;i1++)
        {
          int i0;
          fgets( /*UpperRotationStateName*/Abuff, STATE_NAME_LENGHT_MAX, fp_combdiff) ;
          //UpperRotationStateName[strlen(UpperRotationStateName)]=0;
          fgets(Abuff,80,fp_combdiff);
          sscanf(Abuff,"%s %d",br, &ncd); ecu=atof(br);
          for(i0=0;i0<ncd;i0++)
          {
            fgets(ground[i0],STATE_NAME_LENGHT_MAX,fp_combdiff);
            ground[i0][strlen(ground[i0])-1] = 0x0 ;
            fgets(Abuff,80,fp_combdiff);   LowVibName[i0][0] = 0x0;
            sscanf(Abuff,"%s %s %s %s",br,br1,bstrength, LowVibName[i0]);
            LowVibName[i0][strlen(LowVibName[i0])-1] = 0x0 ;

            eclow[i0]=atof(br); nucalc[i0]=atof(br1); scalc[i0]=atof(bstrength);

            if(strlen(LowVibName[i0])==0)
                strcpy(LowVibName[i0],WorkSpace.name[DEF_LOWER_STATE_NAME_INDEX]);
          }
        }


        fclose(fp_combdiff);
    }


    if( search_mode == 1 )  //  InputNew
    {

        Abuff[0]=0;
        //stredit(10,10,20,"energy of upper state : ",Abuff,Col,1);
        for(i1=0;i1<COMDIFF_SIZE_MAX;i1++) nucalc[i1] = nucalc[i1] - ecu ;
        ecu = E ;
        for(i1=0;i1<COMDIFF_SIZE_MAX;i1++) nucalc[i1] = nucalc[i1] + ecu ;
    }


    if( WorkSpace.iUseExperienceLowLevels == 1 )
        if( eexp0 != NULL )
    {
        int i1 ;
        for(i1=0;i1<ncd;i1++)
        {
            int i3=/*qjl[i1]*qjl[i1]+qjl[i1]+qtl[i1]*/record_number(ground[i1]);
            if( eexp0[i3]>0 )
            {
               /*
                 if(Opt.CalcFile==1)
                  {
                     eclow[i1]=eexp0[i3];
                     ecu=eclow[i1]+nucalc[i1];
                  }
                  else
                  {
                   eclow[i1]=eexp0[i3]; nucalc[i1]=ecu-eexp0[i3];
                  }
               */
               nucalc[i1]+=eclow[i1];   eclow[i1]=eexp0[i3];
               nucalc[i1]-=eclow[i1];
            }
            else
            {
                if( i3>0 )
                {
                        puts("\n\n\n  Experim. level  is zero ,");
                        printf(" i take calc level  %s \n\nPress any key ...",ground[i1]);
                        //if(mode=='h') getch();
                }
            }
        }
    }


    /* -----------------------------   Search  ----------------------------- */


    if(ncd>0)
    {
             nvar = search1( WorkSpace.ints, WorkSpace.dnu, ncd, WorkSpace.
                             mins/*smin2*/, base_line_res, diffdat, WorkSpace.limit_nbase, WorkSpace.crit );

             //nbase = 1;
    };

    return nvar ;
}











//**************   ****************

void shApline(int iline,int icomb_index)
// SHOW CURRENT LINE IDENTIFICATION
{  int k, iset;
   char disp_ind;
   double error ;


    if( (iline>=0) && (iline<nlinsp) &&(iline< shead.Number) )
    {

        if( ReadLine(fp_LinesBank,iline,&sline) != -1)
        {
            if( apr_disp_bgn==1 ) disp_ind=0x1b/*,0x18*/; else disp_ind=' ';
            error = sline.MissError;

            //j=apr_disp_bgn;

            //sprintf(Abuff,"%2d)  ",icomb_index+1);

            for(iset = 0; iset<DEF_ASSIGNMENT_FIELDS_NUMBER; iset++)
            {
                if( sline.V_upper[iset][0] >15  )
                {
                    sprintf(cDisplayLinesAssignmentFields[iset],"Note: %13s  V:%17s    R:%12s    R':%12s  V':%17s ;",sline.Note[iset],
                           sline.V_upper[iset], sline.upper_state[iset],
                           sline.ground_state[iset],sline.V_ground[iset]);
                }
                else
                {
                    sprintf(cDisplayLinesAssignmentFields[iset],"Empty ;") ;
                }
            }

        }
    }
    else
    {
        for(iset = 0; iset<DEF_ASSIGNMENT_FIELDS_NUMBER; iset++)
            sprintf(cDisplayLinesAssignmentFields[iset]," ") ;
    }

}






void showSinglline(int icombline,int ispecline, char *Abuff)
{
  double energ;

    //ispecline-- ;
    //icombline-- ;

    if((ispecline<nlinsp)&&(ispecline>0))
    {
        if(WorkSpace.LowLevelsCombDiff==0)
            energ=eclow[icombline]+dFrequensy[ispecline];
        else energ=eclow[icombline]-dFrequensy[ispecline]; //!!!


        sprintf(Abuff,"%2d)  %20s%17.4f %17.4f %13.3E %20.4f%13.2E  %17.5f  %17.5f",
                        icombline+1, ground[icombline], eclow[icombline], nucalc[icombline],
                        scalc[icombline], dFrequensy[ispecline], dIntensity[ispecline], energ, energ - ecu );
    }
    else
        sprintf( Abuff, "  Not found") ;

}



/**********************************************************
*                                                         *
*    SHOW CURRENT LINE                                    *
*    of combination difference with number  _variant_.    *
**********************************************************/


int shvarline(int line_num,int variant)
{
    int i4;

    i4 = diffdat[variant][line_num] ;

    if( i4 >=0 )
    {
          if( WorkSpace.LowLevelsCombDiff == 0 )
              eexp[line_num] = eclow[line_num] + dFrequensy[i4];
          else
              eexp[line_num] = eclow[line_num] - dFrequensy[i4] ;
    }
    else
    {
          eexp[line_num] = 0.0;
    }




        sprintf(cDisplayLinesFields[0],"  %15s  %15.4f", ground[line_num],eclow[line_num]);

        sprintf(cDisplayLinesFields[1],"  %15.4f   %15.2E",  nucalc[line_num],scalc[line_num]);


        //if( eexp[line_num]>0.0)
        if(i4!=-1)
        {
            sprintf(cDisplayLinesFields[2],"  %15.4f   %15.4e", dFrequensy[i4],dIntensity[i4]);
            sprintf(cDisplayLinesFields[3],"  %15.6f   %15.6f", eexp[line_num], eexp[line_num] - ecu );
        }
        else
        {
            sprintf(cDisplayLinesFields[2],"        not found ") ;
            sprintf(cDisplayLinesFields[3]," " ) ;
        }

        strcpy(Abuff,cDisplayLinesFields[0] ) ;
        strcat(Abuff,cDisplayLinesFields[1] ) ;
        strcat(Abuff,cDisplayLinesFields[2] ) ;
        strcat(Abuff,cDisplayLinesFields[3] ) ;

return 0;
}





int DetectBestVariant()
{
    int i1 ;

    for(i1=0;i1<COMDIFF_SIZE_MAX*3;i1++) ii2[i1]=-1;


BEST:
    int nbest=0, nb;
    double c1=0, c, cTmp;

    for(nb=0;nb<nvar;nb++)
    {
        c=0;
        Average(nb);
        for(i1=0;i1<ncd;i1++)
        {
            if(diffdat[nb][i1]>0)
            {
                cTmp=Conf1( P_x, P_mu[/*Iv-1*/0], i1,nb);
                if(cTmp>0) c+=cTmp;
            }
            if(c>c1)
            {
                c1=c; nbest=nb;
            }
        }
    }

    /*void MarkCombinationRecognition(int ivar) ;

    MarkCombinationRecognition( nbest ) ;

   for(i1=0;i1<ncd;i1++)
        ii2_sub[i1] = ii2[i1] ; //  Save this flags for remove if best wariant is other*/

   return nbest ;
}



void MarkCombinationRecognition(int ivar)
{
    int i1 ;
    double c ;

    for(i1=0;i1<ncd;i1++) ii2[i1]=-1;

    Average(ivar);

    for(i1=0;i1<ncd;i1++)
    {
        if(diffdat[ivar][i1]>0)
        {
              c=Conf1( P_x, P_mu[0], i1,ivar);
              if(c>0.0) ii2[i1]=1;
        }
        else
            ii2[i1]=-1;
    }

   for(i1=0;i1<ncd;i1++)
        ii2_sub[i1] = ii2[i1] ; //  Save this flags for remove if best wariant is other
}







int AskOverwrite(char *str) ;



void Write_Ident(int line_diff, int line_spec, int iset, int mark_index)
{    char Akey;
     int /*i5,*/i6;

    if ( ( ii2[mark_index] > 0 ) && ( line_spec > -1 ) )
        if(  ReadLine(fp_LinesBank,line_spec,&sline) != -1)
    {
        Akey='Y';

        /*i5=2+ncd+line_diff;*/
        if( iset == -1 )
        {
            iset = 0 ;
            double dMinIntensity = 1.0e+20, dTmp ;
            int iMinIntensity = 0 ;
            while( (  sline.V_upper[iset][0]>15 ) && (iset < DEF_ASSIGNMENT_FIELDS_NUMBER ) )
            {
                dTmp = atof(sline.Note[iset]) ;
                if( dMinIntensity > dTmp )
                {
                    dMinIntensity = dTmp ;
                    iMinIntensity = iset ;
                }
                iset++ ;
            }

            if( iset == DEF_ASSIGNMENT_FIELDS_NUMBER )
            {
                iset = iMinIntensity ;
                char buffer[100] ;
                int SelectField(char *buffer) ;
                sprintf(buffer,"Line %d  least absorbtion  Overwrite ?", mark_index+1 ) ;

                iset  = SelectField(buffer) ;
                if( iset == -1 )
                 return ;
                else
                 sline.V_upper[iset][0] = 0 ;
            }
        }

        if(  sline.V_upper[iset][0]>15 )
        {
            Akey = 1 ;
            if(WorkSpace.AskOverwriteMode==1)
            {
                Akey = -1 ;
                if( iOverwriteAllFlag == 0 )
                {
                    Akey = AskOverwrite("Overwrite ?") ;
                    if(Akey == 2) iOverwriteAllFlag = 1 ;
                }
                else
                    Akey = 1 ;
            }

            /*if(WorkSpace.AskOverwriteMode==1)
            {
                while( (sline.V_upper[j][0]>15)&&(j<3) ) j++;
                if(j==3)
                {
                    j--;
                    Akey = AskOverwrite("Overwrite Last ?") ;
                }
            }*/
        }

        if( Akey > 0 )
        {
            sscanf(VibStateNames[WorkSpace.Iv-1],"%s",sline.V_upper[iset]);
            //strcpy(sline.V[j],lhead.Vname[Iv]);
            sprintf( sline.upper_state[iset],"%s",UpperRotationStateName);

            if( sline.upper_state[iset][strlen(sline.upper_state[iset])-1] == 0xd )
                sline.upper_state[iset][strlen(sline.upper_state[iset])-1] = 0x0 ;
            if( sline.upper_state[iset][strlen(sline.upper_state[iset])-1] == 0xa )
                sline.upper_state[iset][strlen(sline.upper_state[iset])-1] = 0x0 ;
            if( sline.upper_state[iset][strlen(sline.upper_state[iset])-1] == 0xd )
                sline.upper_state[iset][strlen(sline.upper_state[iset])-1] = 0x0 ;
            //printf("line_diff=%d  line_spec=%d  ",line_diff,line_spec);

            sprintf( sline.ground_state[iset],"%s",ground[ line_diff ]);
            if( sline.ground_state[iset][strlen(sline.ground_state[iset])-1] == 0xd )
                sline.ground_state[iset][strlen(sline.ground_state[iset])-1] = 0x0 ;
            if( sline.ground_state[iset][strlen(sline.ground_state[iset])-1] == 0xa )
                sline.ground_state[iset][strlen(sline.ground_state[iset])-1] = 0x0 ;
            if( sline.ground_state[iset][strlen(sline.ground_state[iset])-1] == 0xd )
                sline.ground_state[iset][strlen(sline.ground_state[iset])-1] = 0x0 ;
            sprintf(sline.V_ground[iset],"%s", /*WorkSpace.name[DEF_LOWER_STATE_NAME_INDEX]*/ LowVibName[line_diff] );
            sprintf(sline.Note[iset],"%.1e",scalc[line_diff]);
            sline.Frequansy = dFrequensy[line_spec];
            sline.Intensity = dIntensity[line_spec];
            //strncpy(sline.V_ground[j],nameS8],6);
            if( (i6 = WriteLine(fp_LinesBank,line_spec,&sline)) == -1) printf(" Write Error ");
            if( (i6= ReadLine(fp_LinesBank,line_spec,&slinev)) == -1) printf(" Write Error ");
            /*if( strcmp(slinev.upper_state[j],sline.upper_state[j])!=0) cprintf(" Write Error ");
            if( strcmp(slinev.V_upper[j],sline.V_upper[j])!=0) cprintf(" Write Error ");
            if( strcmp(slinev.ground_state[j],sline.ground_state[j])!=0) cprintf(" Write Error ");*/
            if( strcmp(slinev.V_ground[iset],sline.V_ground[iset])!=0)
                printf(" Write Error ");
           //printf("line_diff=%d  i6=%d  ",line_diff,i6);
       }
   }

}






void WriteAssignmentToBase( int ifield )
{
    int i1, i4 ;

    for(i1=0;i1<ncd;i1++) ii2_sub[i1] = -1 ;

    if( iVariant != iVariantBest )
    {
        Average(iVariantBest);
        for(i1=0;i1<ncd;i1++)
        if(diffdat[iVariantBest][i1]>0) teach1( P_x, P_mu[0], i1,iVariantBest,ii2_sub);
    }

    Average(iVariant);
    iOverwriteAllFlag = 0 ;
    for(i1=0;i1<ncd;i1++)
    {
       i4=diffdat[iVariant][i1] ;
       Write_Ident(i1,i4,ifield,i1) ;
       //if( (i4>=0)&&(ii2[i1]>0) )
       if( i4>=0 )
           teach1( P_x, P_mu[0], i1, iVariant,ii2);
    }

}




void Del_Ident(int i4, int j)
{
    if( i4 > -1 )
       if (ReadLine(fp_LinesBank,i4,&sline) != -1)
            if( sline.V_upper[j][0] != 0 )
    {

       sline.V_upper[j][0]=0;   sline.upper_state[j][0]=0;
       sline.ground_state[j][0]=0;
       if(  WriteLine(fp_LinesBank,i4,&sline) == -1) printf(" Write Error ");
    }
}


void remove_curr_lev_ident()
{
    int i,j,change;

    for(i=0;i<nlinsp;i++)
    {
        change=0;

        if( ReadLine(fp_LinesBank,i,&sline) != -1)
          for(j=0;j<3;j++)
            if(  (strcmp(VibStateNames[WorkSpace.Iv-1],sline.V_upper[j])==0)&&
                 (strcmp(sline.upper_state[j],UpperRotationStateName)==0) )
        {
            sline.V_upper[j][0]=0;
            change=1;
        }

        for(j=0;j<2;j++)
           if((sline.V_upper[j][0]==0)&&(sline.V_upper[j+1][0]!=0))
        {
            strcpy( sline.upper_state[j],sline.upper_state[j+1]);
            sline.upper_state[j+1][0]=0;   change=1;
        }

        if(change==1)
            if(  WriteLine(fp_LinesBank,i,&sline) == -1) printf(" Write Error ");
    }
}



static char RotStateName[128] ;


void save_lev(int nl1,int ii, double dP)
{
    InitEnergyBankForModify() ;

    if(WorkSpace.LowLevelsCombDiff==0)
            level.Energy = fabs(dFrequensy[ii]+eclow[nl1]);
    else
            level.Energy = fabs(dFrequensy[ii]-eclow[nl1]);  //!!!

    if(  ReadLine(fp_EnergyBank,ii,&sline) == -1) printf(" Read Error ");

    level.RMS = sline.MissError;
    level.Nlines = 1 ;
    strcpy(RotStateName,UpperRotationStateName);

    dAverageShift = level.Energy - ecu ;

    //printf("%s",RotStateName); getch();
    sprintf(level.Note,"Diff:%7.3f  P:%7.3f ",dAverageShift, dEprobability) ;
    //sprintf(level.Note,"P:%8.5f ",dP);
    WriteLevel(fp_EnergyBank,record_number(UpperRotationStateName),&level, lhead, WorkSpace.Iv-1, RotStateName);

    InitEnergyBankForReadOnly() ;
}



void save_variant_level()
{
     InitEnergyBankForModify() ;

     level.Energy = dEestimation ;
     level.RMS = dEerror ;
     level.Nlines = iEesimation_lines ;
     strcpy(RotStateName,UpperRotationStateName) ;
     sprintf(level.Note,"Diff:%7.3f  P:%7.3f ",dAverageShift, dEprobability) ;


     int i = WriteLevel(fp_EnergyBank,record_number(UpperRotationStateName),&level,lhead , WorkSpace.Iv-1, RotStateName);

     InitEnergyBankForReadOnly() ;
}

void clear_lev()
{
    int i,j;

    InitEnergyBankForModify() ;

    j=0;
    level.Energy = 0 ;
    level.RMS = 0 ;
    level.Nlines = 0 ;
//           for(i=0;i<12;i++) if(level.Energy[i]!=0) j=1;
//           if(j==0) level.Statename[0]=0;
     i = WriteLevel(fp_EnergyBank,/*record_number(UpperRotationStateName)*/WorkSpace.iCurrentRotationState,
                    &level, lhead, WorkSpace.Iv-1, RotStateName);
//           ReadLevel(fp3,ju,tayu,&level);
//           if(level.Energy[Iv] != emean ){ _outtext("error"); getch(); }
     InitEnergyBankForReadOnly() ;
}



void EstimateEnergy()
{
    int i1;
    double omc ;

    dEestimation = 0.0 ;
    dEprobability = 0.0 ;
    dEerror = 0.0 ;
    iEesimation_lines = 0 ;
    dAverageShift = 0.0 ;

    for(i1=0; i1<ncd; i1++) if(ii2[i1]==1)
    {
          iEesimation_lines++;
          dEestimation+= eexp[i1] ;
    }

    Abuff[0] = 0x0 ;
    if(iEesimation_lines!=0)
    {
         dEestimation = dEestimation/iEesimation_lines;
         for(i1=0;i1<ncd;i1++)
         {
             if(ii2[i1]==1)
             {
                   dEerror+= (eexp[i1]-dEestimation)*(eexp[i1]-dEestimation) ;
             }
         }

         omc = dEestimation - ecu ;

         dEerror = sqrt(dEerror/iEesimation_lines)*1000;
         dAverageShift = omc ;


         Pnorm( P_mu[0]);
         for(i1=0;i1<ncd;i1++)
         {
             if((diffdat[iVariant][i1]>=0)&&(ii2[i1]==1))
             {
                  //use(winAss); gotoxy(0,i1+1);
                  dEprobability+=Conf1( P_x, P_mu[0], i1,iVariant);
             }
         }

         sprintf(Abuff," %6s  %12.4f%6.2f%4d   Diff:%7.3f  P:%7.3f ",VibStateNames[WorkSpace.Iv-1],dEestimation,dEerror,iEesimation_lines,dAverageShift, dEprobability);
     }
}


void get_single_line_indexes(int Ij,int *nl1,int *ii, int iSingleLinesViewNumber )
{
    int i;
    int fifi;
    *nl1=Ij/iSingleLinesViewNumber;
    double omc=nucalc[*nl1];
    i=number(omc,2.5,&fifi);
    *ii=i+Ij-(Ij/iSingleLinesViewNumber)*iSingleLinesViewNumber - (iSingleLinesViewNumber-1)/2;
}



void save_level_single_line( int i, int iSingleLinesViewNumber )
{
    int nl, ii ;
    double dP ;

    get_single_line_indexes(i, &nl, &ii, iSingleLinesViewNumber) ;
    dP = ConfS(  P_x , P_mu_s[0], i, iSingleLinesViewNumber ) ;
    save_lev( nl,  ii, dP) ;
}





void TakePredictionFileData()
{

}




/*for(i=0;i<COMDIFF_SIZE_MAX;i++) ii2[i]=-1;
 for(i=0;i<Nn;i++) {
//          _settextposition(3+i,1);
     c= ConfS(  P_x , P_mu_s[0], i ) ;
     if(c>c1) { c1=c; Ij=i; }
       if(c>0.0) ii2[i]=1;
                    };*/



 void MarkSingleLinesRecognition(int ivar)
 {
     /*int i1 ;
     double c ;

     for(i1=0;i1<ncd;i1++) ii2[i1]=-1;

     for(i1=0;i1<ncd;i1++)
     {
         if(diffdat[ivar][i1]>0)
         {
               c=Conf1( P_x, P_mu[0], i1,ivar);
               if(c>0.0) ii2[i1]=1;
         }
         else
             ii2[i1]=-1;
     }

    for(i1=0;i1<ncd;i1++)
         ii2_sub[i1] = ii2[i1] ; //  Save this flags for remove if best wariant is other*/
 }

