#include <stdio.h>
//#include <conio.h>
#include <stdlib.h>
//#include <io.h>
#include <math.h>

#include "specdb.h"

double *f_order;
int    *n_order;




int ReadLine(FILE *fp,int Number,Line_type *buffer)
{  long Position;

 Position=
  (long)sizeof(LinesHead_type)
   +
   (long)(sizeof(Line_type)) * (long)(Number);

 fseek(fp,Position,SEEK_SET);
 return fread(buffer,sizeof(Line_type),1,fp) ;
}


int WriteLine(FILE *fp,int Number,Line_type *buffer)
{ long Position;

 Position=
  (long)sizeof(LinesHead_type)
   +
   (long)(sizeof(Line_type)) * (long)Number;
//printf("%ld\n",Position);
 fseek(fp,Position,SEEK_SET);
return fwrite(buffer,sizeof(Line_type),1,fp) ;

}





/******************    LevelsDataBank    *****************/

long int LevelPos(int Number,LevelsHead_type lhead, int Band)
{
  long Position;

 Position=
  (long)sizeof(LevelsHead_type)
   + sizeof(VIBRATION_STATE_NAME_TYPE)*lhead.Nbands
   + (long)( lhead.RotationStateSize ) * (long)(Number)
   + (long)(sizeof(Level_type)*(Band)) + (long)(sizeof(VIBRATION_STATE_NAME_TYPE));
return Position;
}

long int LevelNamePos(int Number,LevelsHead_type lhead)
{
  long Position;

 Position=
  (long)sizeof(LevelsHead_type)
   + sizeof(VIBRATION_STATE_NAME_TYPE)*lhead.Nbands
   + (long)( lhead.RotationStateSize ) * (long)(Number);
return Position;
}


int ReadLevel(FILE *fp,int Number, Level_type *buffer ,LevelsHead_type lhead, int Band)
{
     fseek(fp,LevelPos(Number,lhead,Band),SEEK_SET);
 return fread(buffer,sizeof(Level_type),1, fp) ;
}

int ReadLevelName(FILE *fp,int Number, LevelsHead_type lhead, VIBRATION_STATE_NAME_TYPE RotStateName)
{
    fseek(fp,LevelNamePos(Number,lhead),SEEK_SET);
return fread(RotStateName,sizeof(VIBRATION_STATE_NAME_TYPE),1, fp) ;
}



int WriteLevel(FILE *fp,int Number,Level_type *buffer,LevelsHead_type lhead, int Band, VIBRATION_STATE_NAME_TYPE RotStateName)
{

    fseek(fp,LevelNamePos(Number,lhead),SEEK_SET);
    fwrite(RotStateName,sizeof(VIBRATION_STATE_NAME_TYPE),1,fp) ;

    fseek(fp,LevelPos(Number,lhead,Band),SEEK_SET);

return fwrite(buffer,sizeof(Level_type),1, fp) ;
}

