#include <QtGui/QApplication>
#include "mainwindow.h"


#include <qapplication.h>
#include <stdio.h>
#include <stdlib.h>
#include <QDebug>


void myMessageOutput(QtMsgType type, const char *msg)
{
        FILE *file;
        file = fopen("file.log", "a");
     switch (type) {
     case QtDebugMsg:
         fprintf(file, "Debug: %s\n", msg);
         break;
     case QtWarningMsg:
         fprintf(file, "Warning: %s\n", msg);
         break;
     case QtCriticalMsg:
         fprintf(file, "Critical: %s\n", msg);
         break;
     case QtFatalMsg:
         fprintf(file, "Fatal: %s\n", msg);
         abort();
     }
        fclose(file); //  
}



int main(int argc, char *argv[])
{
    qInstallMsgHandler(myMessageOutput);
    QApplication a(argc, argv);
    MainWindow w;
    //void LoadWorkSpace(const char *name) ;

    //LoadWorkSpace("task.wsp") ;
    w.show();

    qDebug() << "Zero";

    return a.exec();
}
