/*#include <graph.h>*/
#include <math.h>
//#include <conio.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>

#include "p_types.hpp"
#include "func.hpp"




#define EXTERN
#include "glob_var.h"





static Xvector X;

/*                        EXTERN USED FUNCTIONS                   */
double spec(int i);
float stren(int i);
int number(double nu,float dnu,int *f);
/*                            ***********                            */


//static char Abuff[100];
/*Pvector Pvector::Pvector(long lNum)
{ Pvector.x = new(LNum);
  Pvector.P_size = lNum ;
}

Pvector::~Pvector()
{ delete Pvector.x ;
}
*/



void Average(int variant)
{ int line_num,i,i4,i5;
  double Sexp[COMDIFF_SIZE_MAX], Scalc[COMDIFF_SIZE_MAX], Eexp[COMDIFF_SIZE_MAX];
  double Dsexp,Dscalc;

    averageS=0; averageE=0; Avscalc=0;  averageS2=0;     i5=0;
    full_intensity=0; full_found_intens=0;  Korell=0;  Dsexp=0;  Dscalc=0;

    averageLogSexp=0; sverageLogScalc=0;

    for(line_num=0;line_num<ncd;line_num++)
    {
        if(diffdat[variant][line_num]>=0)
        {
            i4=diffdat[variant][line_num] ;
            averageS2=averageS2+fabs(scalc[line_num]/dIntensity[i4]);
            Avscalc=Avscalc+scalc[line_num];
            averageS=averageS+dIntensity[i4];
            full_found_intens+=scalc[line_num];
            Sexp[i5]=dIntensity[i4];  Scalc[i5]=scalc[line_num];
            if(WorkSpace.LowLevelsCombDiff==0) Eexp[i5]=eclow[line_num]+dFrequensy[i4];
            else Eexp[i5]=eclow[line_num]-dFrequensy[i4];//!!!
            averageE+=Eexp[i5];
            averageLogSexp+=log(fabs(dIntensity[i4]));
            sverageLogScalc+=log(scalc[line_num]);
            i5++;
        }
        full_intensity+=scalc[line_num];
    }


    if(i5>0)
    {
        averageS2=averageS2/i5;
        Avscalc=Avscalc/i5;
        averageS=averageS/i5;
        averageE=averageE/i5;
        averageLogSexp/=i5;
        sverageLogScalc/=i5;
    }

    Korell=0.0;
    for(i=0;i<i5;i++)
    {
        Korell+=(Scalc[i]-Avscalc)*(Sexp[i]-averageS);
    }
    Korell/=i5;


    dEnergDisp=0;

    //printf("ᯥᨨ");
    Dsexp=0.0;  Dscalc=0.0;
    for(i=0;i<i5;i++)
    {
        Dscalc+=(Scalc[i]-Avscalc)*(Scalc[i]-Avscalc);
        Dsexp+=(Sexp[i]-averageS)*(Sexp[i]-averageS);
        dEnergDisp+=(Eexp[i]-averageE)*(Eexp[i]-averageE);
    }
    if(i5<2)
    {
        printf(" ERROR i5<2 "); i5=2;  //getch();
    }
    dEnergDisp/=i5-1;
    Dscalc/=i5-1;
    Dsexp/=i5-1;
    if(Dscalc<=0.0 )
    {
        Dscalc=1.0; printf(" ERROR Dscalc=0.0 ");  //getch();
    }
    if(Dsexp<=0.0)
    {
        Dsexp=fabs(averageS/100); /*printf(" ERROR Dsexp=0.0 ");  getch();*/
    }
    /*printf("ᯥᨨ ED%e Dc%e De%e Kk%e \n",dEnergDisp,Dscalc,Dsexp,Korell);*/
    Korell/=sqrt(Dscalc)*sqrt(Dsexp);
    /*printf("Average");*/
//return 0;
}

void Average_Scalc()
{ int line_num;

    Avscalc=0;
    for(line_num=0;line_num<ncd;line_num++)
        Avscalc=Avscalc+scalc[line_num];
    Avscalc=Avscalc/ncd;
}



void reset(Pvector Vec)
{   int i;
    for(i=0;i<P_size;i++) Vec[i]=0;
};

int Pread(Pvector Vec, FILE *ccc)
{   int j;
    double D;

    for(j=0;j<P_size;j++)
    {
        fscanf(ccc,"%s",Abuff);
        D=atof(Abuff);
        Vec[j]=D;
        //printf("\n %e ",Vec[j]);
    }
//          fread(Vec,sizeof(double),P_size ,ccc);
//          fread(&(Vec->x),sizeof(double),Vec->P_size ,ccc);
return 0;
};

int Pwrite( Pvector Vec, FILE *ccc)
{    int j;

     for(j=0;j<P_size;j++)
         fprintf(ccc," %e ",Vec[j]);
//          fwrite(Vec,sizeof(double),P_size ,ccc);

return 0;
};




void add(Pvector vec1, Pvector vec2)
{
   int i;

    for(i=0;i<P_size;i++)
        vec1[i]=vec1[i]+vec2[i];
//return vec_tmp;
}


void sub(Pvector vec1, Pvector vec2)
{
   int i;

    for(i=0;i<P_size;i++)
        vec1[i]-=vec2[i];
//return vec_tmp;
}

void multconst(Pvector vec, double coef)
{
   int i;

    for(i=0;i<P_size;i++)
        vec[i]=vec[i]*coef;
//return vec;
}


double mult( Pvector vec1,Pvector vec2)
{
   int i;
   double k;
   k=0;

    for(i=0;i<P_size;i++)
         k = k + vec1[i]*vec2[i];
return k;
}




void Pnorm(Pvector P)
{ double Pn;
  int i;

  Pn=sqrt(mult(P,P))*10;
  if( (fabs(Pn-0.1)>1.0e-06)&&(Pn!=0.0) )
   for(i=0;i<P_size;i++)
       P[i]/=Pn;
}





void Assign( Pvector P , Xvector X)
{
    int ii[10],i,k,j,power;

    reset(P);
    for(i=0; i<X_size; i++) ii[i]=0;
    j=0;
    while( ii[X_size-1] <= B_size )
    {
        P[j]=1.0; // printf(" j=%d ",j);
        for(i=0;i<X_size;i++)  if( ii[i]>0 ) P[j]=P[j]*He( ii[i], X[i] );
        if( j< P_size ) j++;
        ii[0]++;
        for(i=0;i<X_size-1; i++)
        {
            power=0;
            for(k=0;k<X_size; k++) power+=ii[k];
            if( power > B_size )
            {
                ii[i]=0;  ii[i+1]++;
            }
       }
    }
//P.x[0]=0;
//getch();
}


double t1=1.0 , t2=1.0;

static double Ax[7]={
       0.625399,
       0.487366,
       1.377189,
      -0.051932,
       0.296243,
      -0.283526,
       1.203221
                   };
static double Dx[7]={
       1.879265,
       1.456075,
       2.250435,
       0.971968,
       1.081995,
       1.100029,
       1.634474
                    };


double Conf1( Pvector P_x, Pvector P_mu, int line_num, int variant)
/*
Ŀ
   楯஭                           

*/
{ int i4,i;
  double  s,NU_c,NU_exp,s11;
  float INTENS_c,INTENS_exp;

    i4 = diffdat[ variant][ line_num];

    NU_c=nucalc[ line_num ];
    NU_exp=dFrequensy[i4];
    INTENS_c=scalc[ line_num ];
    INTENS_exp=dIntensity[i4];
    if(INTENS_c==0)
    {
        //puts("\n CALC INTENSITY =0 "); getch();
    }
    if(INTENS_exp==0)
    {
        //puts("\n EXP INTENSITY =0 "); getch();
    }


    // FREQUANCY
    X[0]= log(1.0+fabs(NU_c-NU_exp)*10) ;

    // STRENGTH ⪫
    if(INTENS_c<INTENS_exp) s=INTENS_c; else s=INTENS_exp;
    //if(s!=0){
    X[1]=log(1.0+fabs(INTENS_c-INTENS_exp)
       /(INTENS_exp+INTENS_c)/20)*100 /*  /s  */;
    //X[1]=(log(fabs(INTENS_c-INTENS_exp))-log(fabs(s)));
    /*        }
        else
        {
        printf("error s");getch();
        }
    */
    // ENERGY  ⪫
    if(WorkSpace.LowLevelsCombDiff==0) s=eclow[line_num]+NU_exp;
    else s=eclow[line_num]-NU_exp;//!!!
    X[2]=fabs(averageE-s)*1000  /* *10*/;


    // STRENGTH /*襭*/  
    s=log10(1.0+((averageS+Avscalc)/2-INTENS_exp)/INTENS_exp);
    X[3]=s*2 /* INTENS_exp*/ /*-s12*/;


    // STRENGTH ய樮 쭮
    s=(fabs(INTENS_exp*averageS2));
    s11=(fabs(INTENS_c*Avscalc));
    X[4]=/*log(1.0+log(1.0+fabs(s11-s)/(INTENS_exp+INTENS_c)))*/ (1.0-Korell)*5;


    // ⢥ত     ⥭ᨢ
    X[5]=log(1.0+log(fabs(full_intensity/full_found_intens)))*5;


    //  筮 ᮡ .      
    X[6]=sqrt(dEnergDisp)*1000;


    for(i=0;i<X_size;i++) X[i]=(X[i]-Ax[i])/Dx[i];

    Assign(P_x, X );
    //multconst(P_x, 0.1);
    s= mult( P_mu , P_x  );
    if( WorkSpace.showmode==3 )
    { /*  DEBUG  */
      /*gotoxy(0,line_num);*/
      //cprintf("%5.2f %5.2f   E:%5.2f i:%5.2f (1-K):%5.2f  Ic/Ie:%5.2f D{E}%5.2f   F=:%8.5f ",
      //                  X[0],X[1],X[2],X[3],X[4],X[5],X[6],s);
    }
return s ;
}


FILE *fp_obs;



void teach1( Pvector P_x, Pvector P_mu, int line_num,int variant,int *classification)
/*
Ŀ
 ADUCATION                                            

*/

{ int i,i4, k, change, write;

  double coef,s,norm;

k=0;     write=0;
do{                     change=0;
 s= Conf1( P_x, P_mu, line_num, variant);
 norm=1.0e-07+ mult(P_x , P_x);
 coef=  ( fabs(s) )  / norm +0.001;

/* coef=  ( fabs(s) ) * 0.2  ; */ /*  FROM FLDL4 - version */
/* if(coef<0.0001) coef= 0.000001 ;*/
 //i4=diffdat[ variant][ line_num]-1;
//cprintf("\n%d  %f\n",classification[ line_num],s); getch();
 if( ( classification[ line_num]==1 )&&( s<=0.0 ) )
   {  multconst(P_mu,1.0-coef);
            /*fp_obs=fopen("trueline.tmp","at");
            for(i=0;i<7;i++) fprintf(fp_obs,"%15.5f",X[i]);
            fprintf(fp_obs,"\n");
            fclose(fp_obs);*/
//            printf("TrueLine"); getch();
      multconst(P_x,coef);
      add(P_mu , P_x ) ;  change=1;
      write=1;
      Pnorm(P_mu);
   }
 if( ( classification[ line_num]<=0 )&&( s>0.0 ) )
   {  multconst(P_mu,1.0-coef);
      multconst(P_x,coef);
      sub(P_mu, P_x) ;    change=1;
      write=1;
      Pnorm(P_mu);
      //cprintf("S");  getch();
   }
  k++;
  }while((k<10)&&(change==1));

//i4=diffdat[ variant][ line_num]-1;


/*if(write==1)
  {
fp_obs=fopen("obs.tmp","at");
fprintf(fp_obs,"# %d \n",classification[ line_num]);
fprintf(fp_obs,"  %15.5e   %15.5e\n",nucalc[ line_num ],spec(i4));
fprintf(fp_obs,"  %15.5e   %15.5e\n",scalc[ line_num ], stren(i4));
fprintf(fp_obs,"  %15.5e   %15.5e\n",dEnergDisp, fabs(averageE-spec(i4)-eclow[line_num]));
fprintf(fp_obs,"  %15.5e   %15.5e\n", averageE, averageS);
fprintf(fp_obs,"  %15.5e   %15.5e\n", Korell, Avscalc);
fprintf(fp_obs,"  %15.5e   %15.5e\n", full_intensity, full_found_intens );
fprintf(fp_obs,"  %15.5e   %15.5e\n", averageLogSexp, sverageLogScalc);
fclose(fp_obs);
  }*/

//k=sqrt( mult(P_mu , P_mu) );
//multconst(P_mu, 1.0/k );
//return 0;
}






double ConfS( Pvector P_x, Pvector P_mu, int Ij, int iNSingleView)
/*
Ŀ
  楯஭                  

*/
{ int i,ii,nl1;
  double s,NU_c,NU_exp;
  float INTENS_c,INTENS_exp;
  int fifi;
//   char key;
    nl1=Ij/iNSingleView;
    NU_c=nucalc[nl1];
    i=number(NU_c,2.5,&fifi);  ii=i+Ij-(Ij/iNSingleView)*iNSingleView - (iNSingleView-1)/2;

    if( ii<0 ) return -100;

    NU_exp=dFrequensy[ii];
    INTENS_c=scalc[ nl1 ];
    INTENS_exp=dIntensity[ii];


    for(i=0; i<X_size; i++) X[i]=0;


    // FREQUANCY
    X[0]=log(1.0+fabs(NU_c-NU_exp)*10) ;


    // STRENGTH ⪫
    if(INTENS_c<INTENS_exp) s=INTENS_c; else s=INTENS_exp;
    if(s!=0)
    {
        X[1]=log(1.0+fabs(INTENS_c-INTENS_exp)/(INTENS_exp+INTENS_c)/20)*100 /*  /s  */;
        //X[1]=log(1.0+fabs(INTENS_c-INTENS_exp)/INTENS_exp);
        //X[1]=(log(fabs(INTENS_c-INTENS_exp))-log(fabs(s)));

        // STRENGTH calculated
        X[2]=log(1.0+Avscalc/INTENS_c )*2;
        //tren(ii)+INTENS_c)/20)*100 /*  /s  */;
        //X[1]=log(1.0+fabs(INTENS_c-INTENS_exp)/INTENS_exp);
        //X[1]=(log(fabs(INTENS_c-INTENS_exp))-log(fabs(s)));

        for(i=3;i<X_size;i++) X[i]=0;
        for(i=0;i</*X_size*/ 3 ;i++) X[i]=(X[i]-Ax[i])/Dx[i];


        if( WorkSpace.showmode==3 )
        {
           //cprintf("%8.2f %8.2f     E:%5.2f %8.2f %8.2f %8.2f",X[0],X[1],X[2],
            //                                                            X[3],X[4],X[5]);
        }
    }
    else
    {
        i=0;
        //cprintf("error s");getch();
    }


    Assign(P_x, X );
    s=mult( P_mu , P_x );

    return s;
}


void teach2(  Pvector P_x, Pvector P_mu, int line_num,int *classification, int iNSingleView)
/*
Ŀ
 祭                            

*/
{ int change,i;
  double s;
  double coef,norm;

    i=0;
    do{
        change=0;
        s=ConfS( P_x, P_mu, line_num, iNSingleView);
        norm=1.0e-7+ mult(P_x , P_x);
        coef= fabs(s)  / norm +0.001 ;

        /* coef= ( fabs(s) ) * 0.2  ;*/  /*  FROM FLDL4 - version  */
        /* if(fabs(coef)<0.001) coef= 0.00000001 ;*/

        if( ( classification[ line_num]>0 )&&( s<=0.0 ) )
        {
            //multconst(P_mu,1.0-coef);
            // printf("gamma=%f  ",coef);  getch();
            multconst(P_x,coef);
            add(P_mu , P_x ) ; change=1;
            Pnorm(P_mu);
        }
        if( ( classification[ line_num]<=0 )&&( s>0.0 ) )
        {
            multconst(P_mu,1.0-coef);
            multconst(P_x,coef);
            sub(P_mu, P_x) ; change=1;
            // printf("gamma=%f  ",coef);  getch();
            Pnorm(P_mu);
        }
        i++;
    }while( (change==1)&&(i<50) );

//return 0;
}


