#include <stdio.h>
//#include <conio.h>
#include <math.h>

#define EXTERN
#include "glob_var.h"

/*extern  int  nlinsp;

extern  int limit_nbase,crit;


extern float  scalc[COMDIFF_SIZE_MAX];
extern double nucalc[COMDIFF_SIZE_MAX];
//extern double *spectrum;
double spec(int i);
*/
int number(double nu,float dnu,int *f);




/*
-------------------------------------------------------------------
  Combination differences search,  result is stored to arrays     
  n_base_line[30]  and  diffdat[30][20]                           
  Returns the number of combinations founded.                     
L-------------------------------------------------------------------
*/

int search1(int N_around, float dnu, int ncd, float smin2,
                          int *n_base_line, int diffdat[COMDIFF_NUMBER_MAX][COMDIFF_SIZE_MAX], int limit_nbase, int crit)
{   int i,ini,fin,j,nstr,km,k;
    int ndiff,nbaseline,kbase,limit,nfoundlines,same;
    int k_order[100];
    double nu,nubase,shift;
    float sbase;
    int find,found;


    found=0;

    for(i=0;i<COMDIFF_NUMBER_MAX;i++) for(j=0;j<COMDIFF_SIZE_MAX;j++) diffdat[i][j]=-1;


    /*  Sorting combination lines by intensity   */

    for(i=0;i<=ncd-1;i++) k_order[i]=i;

    nstr=0;
    for(j=0;j<ncd-1;j++)
    {
         sbase=scalc[j];
         for(i=j+1;i<ncd;i++)
           if( scalc[i]>sbase )
         {
               sbase=scalc[i]; km=k_order[j];
               k_order[j]=k_order[i]; k_order[i]=km;
         }

         if( scalc[j]>smin2 ) nstr=nstr+1;
    }


    ndiff=0;


    /*  Test what is greater: combination lines number or base line limit */

    if( ncd>limit_nbase ) limit = limit_nbase; else limit=ncd ;
    if( limit>nstr ) limit=nstr ;




    /*     Differences search      */

    for(nbaseline=0; nbaseline<limit; nbaseline++)
    {

        kbase=k_order[nbaseline];
        nubase=nucalc[ kbase ];
        sbase = scalc[ kbase ];


        j=number(nubase,0.1,&find);

        ini=j-N_around;
        if( ini<1 ) ini=0;

        fin=j+N_around;
        if( fin>=nlinsp ) fin = nlinsp-1;

        for(j=ini; j<=fin; j++)
        {

            n_base_line[ndiff]=nbaseline;
            nu=dFrequensy[j];
            shift = nu-nubase ;
            diffdat[ndiff][kbase] = j ;

            nfoundlines = 1 ;

            for(i=0; i<ncd; i++)
             if( i!= kbase )
            {
                 diffdat[ndiff][i] = number( nucalc[i]+shift, dnu , &found );
                 if( found==1 )
                     nfoundlines++;
                 else diffdat[ndiff][i] = -1 ;
            }


            //  Test is this combination repeating
            same=0;
            if(ndiff>0)
            {
                k=0;  same=0;
                while( (k<ndiff)&&(same==0) )
                {
                    same=1;
                    for(i=0; i<ncd; i++)
                        if( diffdat[k][i]!=diffdat[ndiff][i] ) same=0;
                    k++ ;
                }
            }

            if( (same==0)&&(nfoundlines>=crit) ) ndiff++ ;
            if( ndiff >= 100 ) return ndiff;
        }
    }

return ndiff;
} /*search*/

