#include<math.h>
#include<stdio.h>
#include<stdlib.h>
//#include<conio.h>
#include "flcalc54.h"

#define C2V 0
#define CS  1

extern int SymType;


//  ****************** Mel Dipm ************************
float mel(int j,int k,int v,int jsh,int ksh,float d[SVECSIZE],int nva,int nvb, int Type)
{     int n,dj,dk,m,nn, Npars;
      int FlagA,FlagB;
      float el,sq;
      float fix,fiz,e,p,s;

Npars=16;


      dj=jsh-j;
   if( dj==-1 ) m=-j;
   if( dj==1 ) m=j+1;
      n=abs(ksh-k);
   if( ksh-k>0 ) dk=1;
   if( ksh-k<0 ) dk=-1;
   if( ksh-k==0 ) dk=0;
      el=0;
   if( abs(j-jsh)>1 ) goto l108;
   if( n>3 ) goto l108;
      fix=0;    fiz=0;
   if( (dj==0) && ((dk==1) || (dk==-1)) ) {
           sq=(2*j+1)*(j-k*dk)*(j+k*dk+1);  sq=(sq/j)/(j+1);
           fix=0.5*sqrt(sq);
                                          };
   if( ((dj==1) || (dj==-1)) && ((dk==1) || (dk==-1)) ) {
           sq=(m+k*dk)*(m+1+k*dk);  sq=sq/abs(m);
           fix=-dj*dk*0.5*sqrt(sq);
                                          };
   if( (dj==0) && (dk==0) ) {  sq=(2*j+1); sq=sq/(j*(j+1));
                      fiz=k*sqrt(sq);
//                        printf("j=%d  sq=%f  fiz=%f\n",j,sq,fiz);
                      };
   if( ((dj==1) || (dj==-1)) && (dk==0) ) {
           sq=(m*m-k*k); sq=sq/abs(m);
           fiz=sqrt(sq);
                                          };


         nn=Npars*(v-1);    e=0;
         if( Type==-1) nn+=8; //    ᥩ 

   FlagA=0; FlagB=0;
   if( (v<=nvb)||(SymType==CS) ) FlagA=1;
   if( (v >nvb)||(SymType==CS) ) FlagB=1;

 if( FlagA==1)      /* v<=nvb   and CS */
   {  
    if( n==0 )
      {
        e=fiz*d[nn];
        p=j*(j+1)+(j+dj)*(j+dj+1);
        e=e+p*fiz*d[nn+1];
        e=e+2*k*k*d[nn+2]*fiz;
        if( dj==0 ) p=0; else p=m;
        e=e+p*fiz*d[nn+3];
        if( dj==0 ) p=2*(j*(j+1)-k*k)-1; else p=-(1+2*k*k);
        e=e+p*fiz*d[nn+4];
      }

   if( n==2 )
     {
       if( dj==0 )
         { sq=(j-k*dk-1)*(j+k*dk+2);
           p=sqrt(sq);
         } else
         {
           sq=(m-k*dk-1)*(m+k*dk+2);
           p=sqrt(sq);
         }
       e=e+dk*p*fix*d[nn+5];
       e=e+2*(k+dk)*p*fix*d[nn+6];
       if( dj==0 ) s=2*(k+dk); else s=-2*dk*(m-1-k*dk);
       e=e+s*p*fix*d[nn+7];
     }
   }

 if( FlagB==1 )     /* v>nvb   and CS */
   {
    if( n==1 )
      {
        e=fix*d[nn];
        p=j*(j+1)+(j+dj)*(j+dj+1);
        e=e+p*fix*d[nn+1];
        e=e+(k*k+(k+dk)*(k+dk))*fix*d[nn+2];
        e=e+(1+2*k*dk)*fix*d[nn+3];
        s=1+2*k*dk;
        if( dj==0 ) p=s; else p=s-2*m;
        e=e+p*fix*d[nn+4];
        if( dj==0 ) p=s*s; else p=s*(s-2*m);
        e=e+p*fix*d[nn+5];
        if( dj==0 ) p=j*(j+1)-k*dk-k*k-1;
          else      p=-(m*(m-1)-(2*m-1)*k*dk+k*k+1);
        e=e+p*fix*d[nn+6];
      }
   if( n==3 ) {
    if( dj==0 ) {sq=(j-k*dk-1)*(j-k*dk-2)*(j+k*dk+2)*(j+k*dk+3);
                 p=sqrt(sq);
                } else { sq=(m-k*dk-1)*(m-k*dk-2)*(m+k*dk+2)*(m+k*dk+3);
                 p=sqrt(sq);
                        };
         e=e+p*fix*d[nn+7];
              };
   }     
         el=e;
//           printf("mel el %f \n",el);
l108: ;       return el;
};/*mel*/

//  **************** Mwang Dipm ******************

float mwang(int j,int k,int ga,int v,int jsh,int ksh,int gash,
                                  float d[SVECSIZE],int nva,int nvb, int Type)
{   float gk,gksh,a1,a2,a3,a4;
    float el;
    int k0,k10;


   if( k==0 ) gk=(1.00)/sqrt(2.0); else gk=1.0;
   if( ksh==0) gksh=(1.00)/sqrt(2.0); else gksh=1.0;

//printf("gk=%f,gksh=%f,ga=%d,gash=%d,k=%d,k0=&d,ksh=%d,k10=%d\n",
//               gk,gksh,ga,gash,k,k0,ksh,k10);getch();
//printf("j=%d,k=%d,jsh=%d,ksh=%d,nva=%d,nvb=%d\n",j,k,jsh,ksh,nva,nvb);
         a1=mel(j,k,v,jsh,ksh,d,nva,nvb, Type);  k0=-k;  k10=-ksh;
         a2=mel(j,k0,v,jsh,k10,d,nva,nvb, Type);
         a3=mel(j,k0,v,jsh,ksh,d,nva,nvb, Type);
         a4=mel(j,k,v,jsh,k10,d,nva,nvb, Type);
            el=gk*gksh/2*(a1+ga*gash*a2+ga*a3+gash*a4);

return el;
};/*mwang*/

/* ****************************** Dipm *****************************   */
float dipm(int j,int tay,int jsh,int taysh,int vsh,int nva,int nvb,
                 float c0[SVECSIZE],float c[SVECSIZE],float d[SVECSIZE], int SymType)
{
   int nv,ni,mi,na,nb,ma,mb,nl,l,ml,v,n,nsh,nn,k,ksh,i,ka,kc,kash,kcsh,
                                     v0,dka,dkc,ga,gash,gaa,gab;
   int type;
   float el;  float r;

   nv=nva+nvb;    r=0;

     nsh=jsh+taysh+1;    kash=(int)(nsh/2);    kcsh=kash-taysh;
       n=j+tay+1;     ka=(int)(n/2);      kc=ka-tay;
         nn=nsh-4*(int)(nsh/4);
             dka=abs(ka-kash);    dkc=abs(kc-kcsh);

 type=1;
 if( ((vsh>nvb) && (dka==2*(int)(dka/2)))
              && (dkc+1==2*(int)((dkc+1)/2))  ) type=-1;
 if( ((vsh<=nvb) &&   (dka+1==2*(int)((dka+1)/2)))
              && (dkc+1==2*(int)((dkc+1)/2))  ) type=-1;


if(SymType==C2V)
 {
 if( ((vsh<=nvb) &&  (dka==2*(int)(dka/2)))
              && (dkc+1==2*(int)((dkc+1)/2))  ) goto l109;
 if( ((vsh>nvb) &&   (dka+1==2*(int)((dka+1)/2)))
              && (dkc+1==2*(int)((dkc+1)/2))  ) goto l109;
 }


if(SymType==CS)
 {
 if( ( (dka==2*(int)(dka/2)))
              && (dkc+1==2*(int)((dkc+1)/2))  ) goto l109;
 if( ( (dka+1==2*(int)((dka+1)/2)))
              && (dkc+1==2*(int)((dkc+1)/2))  ) goto l109;
 }

      goto l110;
l109:
   if( jsh==2*(int)(jsh/2) ){
         k=(int)(jsh/2);
   if( nn==1 ) {
    if( vsh<=nvb ) { mb=2;   ma=1;   nb=k+1;   na=k;  gab=1;  gaa=-1;
              } else { mb=1;   ma=2;   nb=k;   na=k+1;  gab=-1;  gaa=1; };
                             };
   if( nn==2 ) {
    if( vsh<=nvb ) {mb=1;   ma=2;   nb=k;   na=k+1;  gab=-1;  gaa=1; }
      else { mb=2;   ma=1;   nb=k+1;   na=k;  gab=1;  gaa=-1; };
               };
   if( nn==3 ) {
    if( vsh<=nvb ) { mb=1;   ma=0;   nb=k;   na=k;  gab=1;  gaa=-1; }
      else { mb=0;   ma=1;   nb=k;   na=k;  gab=-1;  gaa=1; };
               };
   if( nn==0 ) {
    if( vsh<=nvb ) { mb=0;   ma=1;   nb=k;   na=k; gab=-1; gaa=1; }
       else {  mb=1;   ma=0;   nb=k;   na=k;   gab=1;   gaa=-1; };
               };
        } else { k=(int)((jsh+1)/2);
                 if( nn==1 ) {
                if( vsh<= nvb ) { mb=2; ma=1; nb=k; na=k; gab=1; gaa=-1; }
               else { mb=1;  ma=2;   nb=k;   na=k;   gab=-1;   gaa=1;   };
                             };
                 if( nn==2 ) {
                if(vsh<=nvb) { mb=1; ma=2; nb=k; na=k;  gab=-1;   gaa=1; }
                else {  mb=2;   ma=1;   nb=k;   na=k;   gab=1;   gaa=-1; };
                             };
                 if( nn==3 ) {
                 if( vsh<=nvb ) { mb=1; ma=0; nb=k; na=k-1; gab=1; gaa=-1;}
                 else { mb=0; ma=1; nb=k-1; na=k;   gab=-1;   gaa=1;     };
                              };
                 if( nn==0 ) {
                 if( vsh<=nvb ) { mb=0; ma=1; nb=k-1; na=k; gab=-1; gaa=1;}
                 else { mb=1; ma=0; nb=k; na=k-1; gab=1;   gaa=-1;       };
                            };
                };
         n=j+tay+1;
            nn=n-4*(int)(n/4);
          if( j==2*(int)(j/2) ) {
          k=(int)(j/2);
   if( nn==1 ) {  nl=k+1;  ml=2;  ga=1;  };
   if( nn==2 ) {  nl=k;    ml=1;  ga=-1;  };
   if( nn==3 ) {  nl=k;    ml=1;  ga=1;  };
   if( nn==0 ) {  nl=k;    ml=0;  ga=-1;  };
                                } else {
         k=(int)((j+1)/2);
   if( nn==1 ) {  nl=k;  ml=2;  ga=1;  };
   if( nn==2 ) {  nl=k;  ml=1;  ga=-1;  };
   if( nn==3 ) {  nl=k;  ml=1;  ga=1;  };
   if( nn==0 ) {  nl=k-1;  ml=0;  ga=-1; };
                                       };
         r=0;    n=0;
   for(v=1;v<=nv;v++) {
         if( v<=nvb ) { ni=nb;   mi=mb;   gash=gab; }
                 else {  ni=na;   mi=ma;   gash=gaa; };
         for (i=1;i<=ni;i++) {
                n=n+1; ksh=2*i-mi;
               for( l=1;l<=nl;l++) {
                            k=2*l-ml;   v0=v;
                          el=mwang(j,k,ga,v0,jsh,ksh,gash,d,nva,nvb, type);
                           r=r+c[n-1]*c0[l-1]*el;
//                            printf("**el=%f**",el);
                                   };/*l*/
                             };/*i*/
                      };/*v*/
         r=r*r;
l110: return r;
};/*dipm*/
