#ifndef GLOB_VAR_H
#define GLOB_VAR_H


#include "flcalc54.h"

#define PLATFORM_LINUX
//#define PLATFORM_WINDOWS

//#include "specdb.h"
//#include "p_types.hpp"

#ifdef PLATFORM_LINUX
#include <QString>
#define atof(a) QString(a).toDouble() ;
#endif


#ifndef EXTERN


FILE *ccc,*eee;

  char bspectrum[20],bstrength[20],br[20],br1[20];
  char ok,ok1 , mode , command , smode;
  char name[10][60];
  char TYPE_MOLECULE[40];

  int SymType;
  int jl,ju,tayl,tayu,kal,kcl,kau,kcu,ilka,ilkc,
                Iv,nline,nnn,flw,nbase,Invas,Invbs;
  int nvar,v,nv,nj1,nj1l,nj2l,nj2,dka,dkc,ncd,nbest,auto_nj2;
  int v1,v2,crit,ints,
             nva,nvb,numb_diag,numb_res,
             nvaa,nvbb,iatr;
  int found,hoho; /*:boolean;*/
  int qjl[30],qtl[30];
  int number_of_levels;
  int limit_nbase;

  int ypos;
  long int score=0;
  int j,n,nsl;
  int i1,i2,i3,i4,i5,iii,n1,n2,nna,
      nnb,vsh,nxu;

  int nlinsp,model,model1;
  int eigen, j_old;

  int iTmp ;

  float s0,s1,s2,s3,slu, mins,stsum, gt,gt1,low,up,t,dnu,   trmom;

double nu, ecl, ecu, emean, omc;

float pressure,pressure1,puthl,alfad,alfad1,abko,abko1,scpr,disp;
//double br1;

double x0[50],  /*      33 parameters of ground state           */
       xu[2000];  /* parameters of considered    11 vib.states   */

float au[SVECSIZE],
      al[SVECSIZE],
      dimom[500]; /* parameters of dipol moment for 11 bands    */

float svecl[SVECMATRSIZE][SVECSIZE],
      svecu[SVECMATRSIZE][SVECSIZE];

double e0[SVECMATRSIZE],
       eu[SVECMATRSIZE];

double nucalc[30],eclow[30];

float scalc[30];



#else



extern FILE *ccc,*eee;

extern   char bspectrum[20],bstrength[20],br[20],br1[20];
extern   char ok,ok1 , mode , command , smode;
extern   char name[10][60];
extern   char TYPE_MOLECULE[40];

extern   int SymType;
extern   int jl,ju,tayl,tayu,kal,kcl,kau,kcu,ilka,ilkc,
                Iv,nline,nnn,flw,nbase,Invas,Invbs;
extern   int nvar,nv,nj1,nj1l,nj2l,nj2,dka,dkc,ncd,nbest,auto_nj2;
extern   int v1,v2,crit,ints,
             nva,nvb,numb_diag,numb_res,
             nvaa,nvbb,iatr;
extern   int found,hoho; /*:boolean;*/
extern   int qjl[30],qtl[30];
extern   int number_of_levels;
extern   int limit_nbase;

extern   int ypos;
extern   long int score ;
extern   int j,n,nsl;
extern   int i1,i2,i3,i4,i5,iii,n1,n2,nna,
      nnb,vsh,nxu;

extern   int nlinsp,model,model1;
extern   int eigen, j_old;

extern   int iTmp ;

extern   float s0,s1,s2,s3,slu, mins,stsum, gt,gt1,low,up,t,dnu,   trmom;

extern double nu, ecl, ecu, emean, omc;

extern float pressure,pressure1,puthl,alfad,alfad1,abko,abko1,scpr,disp;
//double br1;

extern double x0[50],  /*      33 parameters of ground state           */
       xu[2000];  /* parameters of considered    11 vib.states   */

extern float au[SVECSIZE],
      al[SVECSIZE],
      dimom[500]; /* parameters of dipol moment for 11 bands    */

extern float svecl[SVECMATRSIZE][SVECSIZE],
      svecu[SVECMATRSIZE][SVECSIZE];

extern double e0[SVECMATRSIZE],
       eu[SVECMATRSIZE];

extern double nucalc[30],eclow[30];

extern float scalc[30];


#endif

#endif // GLOB_VAR_H
