/*
                  
                            kwan.cpp             
                                                 
                   ᫥ ᮡ. 祭     
                    ᮡ.஢ .-.  .
                  
*/

#include <stdlib.h>
#include <stdio.h>
//#include <conio.h>
#include <math.h>

#include "flcalc54.h"

#include "jacobi.h"
#include "fzgz.h"

extern int nxu,numb_diag,numb_res;

static int nb,na,neis,ma,mb,ga,gb,model;

static float c[SVECMATRSIZE][MAXBAND];
static double a[SVECSIZE][SVECSIZE];
static float  a1[SVECSIZE][SVECSIZE];
static double s[SVECSIZE][SVECSIZE];

static double f,F[30];

static int n ;


/*
                  
                            MATEL                
                        ᫥       
                        ⮢.               
                  
*/
float matelk(int nva,int nvb,int v,int k,int vs,
                                  int ks,int zi,double *x,int j)
{   double z,zh,m1,m2,m4,m6,gg,m8,m10,m12,m14,m;
    double  c0,c1,c2,ff,fz,gz,m112,m114,m116;
    double m21;
    double  k2,k4,k6,k8,ks2,ks4,ks6,ks8,  mm;
     int beta,ii,c,kl,nv,i;
     double xx[50];


    m=0.0;          nv=nva+nvb;
            if( ks>k ) zh=1.0; else zh=-1.0;
            if( (ks==0) || (k==0) ) z=sqrt(2.0); else z=1.0;
  beta=1;


    for(ii=0;ii<50;ii++) xx[ii]=0;

    for(ii=0;ii<numb_diag;ii++) xx[ii]=x[nv*(ii)+v-1];



k2=k*k;
if(model==3)   // G-Functions
 {
   k2=(2.0/xx[38])*( sqrt(1.0+xx[38]*k*k) - 1.0 );
 }

k4=k2*k2;k6=k2*k4;k8=k6*k2;



if( v==vs) {
    if( k==ks ) {
      m2=(xx[1]-(xx[2]+xx[3])/2.0)*k2;
      m2=m2+(xx[2]+xx[3])*f/2.0;
      m4=-xx[4]*k4-xx[5]*k2*f-xx[6]*F[2];
      m6=xx[9]*k6+xx[10]*k4*f+xx[11]*k2*F[2];
      m6=m6+xx[12]*F[3];
      m8=xx[16]*k8+xx[17]*k6*f;
      m8=m8+xx[18]*k4*F[2]+xx[19]*k2*F[3]+xx[20]*F[4];
      /* xx[26] */
      m10=xx[25]*k4*k6+xx[26]*k8*f+xx[27]*k6*F[2];
      m10=m10+xx[28]*k4*F[3]+xx[29]*k2*F[4]+xx[30]*F[5];
      m12=xx[36]*k6*k6;
      m14=xx[37]*k4*k6*k4;
      m1=0.0;
      m112=0.0;  m114=0.0;  m116=0.0;

      //  xx[33]    xx[34]

      if( k==1 ) {
           m112=(xx[2]-xx[3])/4.0*f;            //?????????????
           m114=-xx[7]*f-xx[8]*F[2];
           m116=xx[13]*f+xx[14]*F[2]+xx[15]*F[3];
           m116=m116+xx[21]*f+(xx[22]+xx[32])*F[2]+(xx[23]+xx[33])*F[3]
                    +(xx[24]+xx[34])*F[4];
           m116=m116+xx[35]*F[5];
           m1=m112+m114+m116;
                 };/* k==1*/

      if( model==2 )
        {
           /* pade-borel */
           c0=m2;c1=m4;c2=m6+m8+m10+m12+m14;
           if(c2<(1.0E-15)) { m=xx[0]+c0+c1+c2;} else{
           /*if( j>0 ) */ fzgz1(c0,c1,c2,beta,&ff,&fz,&gz); /* else ff=0;*/
           m=xx[0]+ff;                               }

           if( k==1 ) {
               c0=m112;c1=m114;c2=m116;
               if(c2<1.0e-15) { m=m+(c0+c1+c2)*zi;
                              }else{
               fzgz1(c0,c1,c2,beta,&ff,&fz,&gz);
               m=m+ff*zi;          };
                      } /* k=1*/
        }  /*model=2*/

      if( (model==1) || (model==3) )
        {
            /* tailor serie */
            m=xx[0]+m1*zi+m2+m4+m6+m8+m10+m12+m14;
            //if((j==2)&&((k==0)||(k==2))) xx[0],m1,zi,m2,m4,m6,m8,m10,m12,m14,m);
        }  /* model=1 */

     }  /* k==ks */

   if( (ks==k+2) || (ks==k-2) )
     {
       ks2=ks*ks;
       if(model==3)   // G-Functions
          {
            ks2=(2.0/xx[38])*( sqrt(1.0+xx[38]*ks*ks) - 1.0 );
            //k2=(2.0/xx[38])*( sqrt(1.0+xx[38]*k*k) - 1.0 );
          }

       ks4=ks2*ks2;ks6=ks2*ks4;ks8=ks6*ks2;
       //k4=k2*k2;k6=k2*k4;k8=k6*k2;
       gg=(j-zh*k-1)*(j-zh*k)*(j+zh*k+1)*(j+zh*k+2);
       gg=sqrt(gg)/2;
       m2=(xx[2]-xx[3])/2;
       m21=-xx[7]*(k2+ks2)-xx[8]*f*2;
       m4=xx[13]*(k4+ks4)+xx[14]*(k2+ks2)*f+2*xx[15]*F[2];
       m6=xx[21]*(k6+ks6)+xx[22]*(k4+ks4)*f;
       m6=m6+xx[23]*(k2+ks2)*f*f+2*xx[24]*F[3];
       m8=xx[31]*(k8+ks8)+xx[32]*(k6+ks6)*f+xx[33]*(k4+ks4)*F[2];
       m8+=xx[34]*(k2+ks2)*F[3]+xx[35]*F[4]*2;

       if( model==2 )
         {                 /* pade-borel*/
            c0=m2; c1=m21;c2=m4+m6+m8;
            if(c2<1.0e-15) {m=z*gg*(c0+c1+c2);
                           } else
              {  fzgz1(c0,c1,c2,beta,&ff,&fz,&gz);
                 m=z*gg*ff;
              }
         }  // model==2

      if( (model==1) || (model==3) )
         m=z*gg*(m2+m21+m4+m6+m8);   /* teilor serie */

     } // ks=k+-2

   } // v==vs
    else {

   //   RESONANCE
   if(model==3)   // G-Functions
        {  k2=k*k;
           k4=k2*k2;k6=k2*k4;k8=k6*k2;

           ks2=ks*ks;
           ks4=ks2*ks2;ks6=ks2*ks4;ks8=ks6*ks2;
        }

   c=numb_res*(int)((v-1)*(v-2)/2+vs-1)+numb_diag*nv;

   if( ((v<=nvb) && (vs<=nvb)) || ((v>nvb) && (vs>nvb)) ) kl=1; else kl=2;
   if( kl==1 ) {
   if( k==ks) {
       m2=x[c]+x[c+1]*k*k+x[c+2]*f;
         m1=0;
         if( k==1 ) m1=zi*(x[c+3]/2*f + x[c+4] * f + x[c+5] * F[2]/2 );
         m=m2+m1;
     }
   if( (ks==(k+2)) || (ks==(k-2)) )
       {
         m=(j-zh*k-1)*(j-zh*k)*(j+zh*k+1)*(j+zh*k+2);
         m= z/2 * sqrt(m) * (x[c+3] + x[c+4] *(k*k + ks*ks) + x[c+5] * f ) ;
       }
     }
   if( kl==2 )
     {
       if( (ks==k+1) || (ks==k-1) )
                    m=(j-zh*k)*(j+zh*k+1);

       mm=zh*x[c+4]+(2*k+zh)*x[c+5]+x[c+3] * zh * (k*k+(k+zh)*(k+zh) );
       mm+= x[c+2] * ( k*k*k+(k+zh)*(k+zh)*(k+zh) ) ;
       mm+= x[c] * zh * ( pow(k,4) + pow( (k+zh) , 4 ) ) ;
       mm+= x[c+1]*zh*f + x[c+6]*(k*2+zh)*f ;
       mm+= x[c+7]*( pow(k,3) + pow( (k+zh) , 3 ) ) * f ;
       mm+= x[c+8]*(k*2+zh) * f*f ;

      m=z/2*sqrt(m)*mm;
      }
    }
  return m;
};/*matel*/


/*
                  
                            MATR                 
                      ନ஢          
                                                 
                  
*/

void matrk(int nva,int nvb, double  *x,int eigen,int j)
{   int i,l,v,mi,zi,ni,k,ks,vs,mj,nj,ji,p,v1,vs1,nv;
    float m;
                nv=nva+nvb;
       na=(int)((j+ma)/2);
       nb=(int)((j+mb)/2);
       n=nva*na+nvb*nb;
  if( eigen==0 ) neis=1; else neis=n;
//    for(l=0;l<20;l++) for(i=0;i<20;i++) a[l][i]=0;
           l=-1;
    for(v=1;v<=nv;v++) {
   if( v<=nvb ) {
       mi=mb; zi=gb; ni=nb;
                } else {
       mi=ma; zi=ga; ni=na;
                        };
   for(i=1;i<=ni;i++) {
        k=2*i-mi; l=l+1; p=-1;
   for(vs=1;vs<=v;vs++) {
    if( vs<=nvb ) {
        mj=mb; nj=nb;
                  } else {
        mj=ma; nj=na;
                         };
   for(ji=1;ji<=nj;ji++) {
        ks=2*ji-mj;  p=p+1;
   if( (v==vs) && (ji>i) ) goto l101;
   if( abs(k-ks)>=3 ) goto l101;
        v1=v;   vs1=vs;
        m=matelk(nva,nvb,v1,k,vs1,ks,zi,x,j);
                    a[l][p]=m;
              a[p][l]=a[l][p];
l101: m=0;
     };/*ji*/
     };/*vs*/
     };/*i*/
     };/*v*/

 };/*matr*/


/*
                  
                            IACOB                
                         ஢   
                    ᮡ. 祭  ஢    
                  
*/
void sort(int n, double *a,int *nom)
{ int i,j,k,m,l;
  double w;

  for(i=1;i<=n;i++) nom[i-1]=i;

  m=n/2;
  while(m!=0)
  {  k=n-m;
     for(j=1; j<=k; j++ )
     {
     for(i=j; i>=1; i=i-m )
     if( a[i+m-1]>=a[i-1] ) goto l5;
       else{
       w=a[i-1]; a[i-1]=a[i+m-1]; a[i+m-1]=w;
       l=nom[i-1]; nom[i-1]=nom[i+m-1]; nom[i+m-1]=l;
           }
l5:; }
     m=m/2;
  }
}


static     int dim[MAXBAND],nvv[MAXBAND],nom[50],ind[MAXBAND][50];
static     float vect1[MAXBAND][50][MAXBAND];
static     double col[50],lev[MAXBAND][50],d[SVECSIZE];


void iacobk(int nva,int nvb,
       double eteor[SVECMATRSIZE],float svec[SVECMATRSIZE][SVECSIZE],int eigen,int j)
{    int k,i,nn,ms,mm,v,vs,maxv,lll,kki,maxl,kk,rot;
     int l,l1,l2,l5,mmk,pp,q;
     double cmax,cc,cmin;
     int nv;
     int ll;

/*
   FILE *fp;


   fp=fopen("mixcoef.res","wt");
*/

               nv=nva+nvb;
   if( n<0.5 ) goto l102;

//for(i=0;i<20;i++) if((s[i]=calloc(77,sizeof(float)))==NULL) exit(1);


   rot=jacobi(n,a,s,eigen);



   for(k=0;k<n;k++)
      {
        d[k]=a[k][k];
/*        if(fabs(d[k]-14801.2519)<1.0)
          {
             printf("%14.5f\n",d[k]); getch();
          }
*/
      }

   for(i=0;i<n;i++)
     for(k=0;k<n;k++)  a1[i][k]=s[i][k];
/*

   for(i=0;i<n;i++)
     for(k=0;k<n;k++)  s[i][k]=a1[k][i];
*/

   for(v=1;v<=nv;v++)
	if(v<=nvb) dim[v-1]=nb; else dim[v-1]=na;

   for(l=0;l<n;l++)
     {
      k=0;
      for(v=0;v<nv;v++)
        {
         c[l][v]=0.0;
         for(i=0;i<dim[v];i++)
           {
            c[l][v]+=s[l][k]*s[l][k];
            k++;
	   }
	}
     }



   for(v=0;v<nv;v++) nvv[v]=0;

   for(l=0;l<n;l++)
     {
      cmax=-1.0;
      for(v=0;v<nv;v++)
        if(c[l][v]>cmax) {
          cmax=c[l][v];
          maxv=v;
                         }

      kki=nvv[maxv];
      for(v=0;v<nv;v++)  vect1[maxv][kki][v]=c[l][v];
      nvv[maxv] ++ ;

      lev[maxv][kki]=d[l];
      ind[maxv][kki]=l+1;

     }

    for(v=1;v<=nv;v++)
      {
l123:  if(nvv[v-1]<dim[v-1])
         {
          cmax=-1.0;
          for(vs=1;vs<=nv;vs++)
            {
            if((v!=vs)&&(nvv[vs-1]>dim[vs-1]))
              {
               for(l=1;l<=nvv[vs-1];l++)
                 {
                   cc=vect1[vs-1][l-1][v-1];
                   if(cc>cmax)
                     {   cmax=cc;
                         maxv=vs;
                         maxl=l;
                     }
                 }
              }
            }
          nvv[v-1] ++ ;
          for(l=1;l<=nv;l++)
             vect1[v-1][nvv[v-1]-1][l-1]=vect1[maxv-1][maxl-1][l-1];

          lev[v-1][nvv[v-1]-1]=lev[maxv-1][maxl-1];
          ind[v-1][nvv[v-1]-1]=ind[maxv-1][maxl-1];
          for(l=maxl;l<=nvv[maxv-1]-1;l++)
            {
             for(k=1;k<=nv;k++)
                vect1[maxv-1][l-1][k-1]=vect1[maxv-1][l+1-1][k-1];

             lev[maxv-1][l-1]=lev[maxv-1][l+1-1];
             ind[maxv-1][l-1]=ind[maxv-1][l+1-1];
            }

          nvv[maxv-1] -- ;
          goto l123;
         }  // if
       }  // do

    l1=0;
    for(v=1;v<=nv;v++)
      {
        kk=nvv[v-1];
	for(k=1;k<=kk;k++) col[k-1]=lev[v-1][k-1];



	//  call sort(kk,col,nom)
           sort(kk,col,nom);

        for(l=1;l<=kk;l++)
          {
            l1 ++ ;
            d[l1-1]=col[l-1];
            k=nom[l-1];
            l5=ind[v-1][k-1];
            for(l2=1;l2<=n;l2++)
                       s[l1-1][l2-1]=a1[l5-1][l2-1];

          }

      }
    lll=0;
    for(v=1;v<=nv;v++)
      {
      if(v<=nvb)
        {
        nn=nb;	ms=mb;  pp=gb;
        }
        else
        {
        nn=na;  ms=ma;  pp=ga;
        }

      if(ms==2)  mm=1;
      if((ms==1)&&(pp==-1)) mm=2;
      if((ms==1)&&(pp==1)) mm=3;
      if(ms==0) mm=4;
      for(i=1;i<=nn;i++)
        {
         lll ++ ;
         q=4*(i-1)+mm;
         mmk=(v-1)*(2*j+1)+q;
         eteor[mmk-1]=d[lll-1];
         for(k=1;k<=n;k++)
            svec[mmk-1][k-1]=s[lll-1][k-1];
        }
      }
  

l102:;
}  //iacob







/*
                  
                            KWAN                 
                                                 
                  
*/
void kwan(int model1, int j, int nva, int nvb, int eigen,
                        double *x, double eteor[SVECMATRSIZE], float svec[SVECMATRSIZE][SVECSIZE])
                          /*j=46*/
{   int nv,i,i1,neign;
    double m;

  f=j*(j+1);

m=f;      F[0]=1.0;  F[1]=f;
for(i=2;i<20;i++) { m*=f;  F[i]=m;  }



  /* ****  {  Kwan*** */
model=model1;
//printf("model=%d  nva=%d  nvb=%d\n",model,nva,nvb);


//for(i=0;i<SVECSIZE;i++)
//  {
//  if((a[i]=(double*)calloc(SVECSIZE,sizeof(double)))==NULL) { puts("\nNot enougth memory  \n"); exit(1); }
//  if((s[i]=(double*)calloc(SVECSIZE,sizeof(double)))==NULL) { puts("\nNot enougth memory  \n"); exit(1); }
//  }


   for(i=0;i<SVECMATRSIZE;i++) for(i1=0;i1<SVECSIZE;i1++) svec[i][i1]=0.0;
   nv=nva+nvb;  neign=nv*(int)(j/2+1);
   if( j==2*(int)(j/2) ) { mb=1;  ma=2;  gb=-1;  ga=1;
                         } else {  mb=1;  ma=0;  gb=1;  ga=-1; };
           matrk(nva,nvb, x,eigen,j);
           iacobk(nva,nvb, eteor,svec,eigen,j);

   if( j==2*(int)(j/2) ) {  mb=0;  ma=1;  } else { mb=2;  ma=1; };
           matrk(nva,nvb, x,eigen,j);
           iacobk(nva,nvb, eteor,svec,eigen,j);
   if( j==2*(int)(j/2) ) {  mb=2;  ma=1;  gb=1;  ga=-1;
                         } else {   mb=0;  ma=1;  gb=-1;  ga=1;  };
           matrk(nva,nvb, x,eigen,j);
            iacobk(nva,nvb, eteor,svec,eigen,j);
   if( j==2*(int)(j/2) ) {  mb=1;  ma=0;  } else {  mb=1;  ma=2; };
           matrk(nva,nvb, x,eigen,j);
           iacobk(nva,nvb, eteor,svec,eigen,j);

//for(i=0;i<SVECSIZE;i++) free(a[i]);
//for(i=0;i<SVECSIZE;i++) free(s[i]);
}  /*kwan*/
