/*#include <QtCore/QCoreApplication>

int main(int argc, char *argv[])
{
    QCoreApplication a(argc, argv);



    return a.exec();
}
*/

/*
                                 
                                           fcalc.cpp            
                                                                
                                   ᫥  樮    
                                    ⥩                    
                                 
*/
#include<stdlib.h>

//#include<process.h>
//#include<conio.h>

#include<stdio.h>
#include<string.h>
//#include <alloc.h>
#include <math.h>
/*#include <graph.h>*/


#include "flcalc54.h"
#include "glob_var.h"



#include "kwan.h"
#include "dipm.h"
#include "analys.h"
#include "fzgz.h"
#include "init5c.h"
#include "calcout5.h"



static char Abuff[80],ko[25] ;


void jtau_to_jkakc(int j,int tau,int *ka,int *kc)
{ int iii;
                 iii=j+tau+1;
                 *ka=iii/2;
                 *kc=*ka-tau;
  if( j==0 ) { *ka=0;  *kc=0;  }
}


//#pragma data(stack_size=>0x8000)

/*
    
     MAIN  module                                                  
       used:  kwan, dipm, search, shlinsp, shouvar                 
    
*/
main(int Iargs, char **Aarg)
{  int i,V;


if(Iargs<3) exit(1);
sscanf(Aarg[1],"%d",&V);
sscanf(Aarg[2],"%d",&ju);
sscanf(Aarg[3],"%d",&kau);
sscanf(Aarg[4],"%d",&kcu);


tayu=kau-kcu;

init();


if( strcmp(TYPE_MOLECULE,"CS")==0 ) SymType=CS; else SymType=C2V;
/*printf("V=%d  j=%d  tau=%d  TYPE of MOLECULE=%s",V,ju,tayu,TYPE_MOLECULE);*/

Iv=V;


/* 
                  ---- end of initialisation ----                 
     */




   mode='h';
 found=0;

nvaa=1;nvbb=0;vsh=1;/*model=1;*/
//           GROUND STATE PARAMETERS
ccc=fopen(name[3],"rt");
for(i1=0;i1<=32;i1++) {
    if( (iTmp=fscanf(ccc,"%s ",Abuff))>0 )
             {
                 x0[i1]=atof(Abuff);
             }
                      };
fclose(ccc);




     /*_clearscreen(_GWINDOW);
                   _settextcolor(7);*/

//           DIPOL MOMENT PARAMETERS
ccc=fopen(name[4],"rt");

/*fscanf(ccc,"%d %d %d  %d  %f %f %f %f %f %f %f", &nva, &nvb,
                                              &numb_diag, &numb_res,
                                              &stsum, &gt,&gt1,&low,
                                              &up,&br,&t);*/
fscanf(ccc,"%s", Abuff ) ;  nva = atoi(Abuff) ;
fscanf(ccc,"%s", Abuff ) ;  nvb = atoi(Abuff) ;
fscanf(ccc,"%s", Abuff ) ;  numb_diag = atoi(Abuff) ;
fscanf(ccc,"%s", Abuff ) ;  numb_res = atoi(Abuff) ;
fscanf(ccc,"%s", Abuff ) ;  stsum = atof(Abuff) ;
fscanf(ccc,"%s", Abuff ) ;  gt = atof(Abuff) ;
fscanf(ccc,"%s", Abuff ) ;  gt1 = atof(Abuff) ;
fscanf(ccc,"%s", Abuff ) ;  low = atof(Abuff) ;
fscanf(ccc,"%s", Abuff ) ;  up = atof(Abuff) ;
fscanf(ccc,"%s", Abuff ) ;  double br = atof(Abuff) ;
fscanf(ccc,"%s", Abuff ) ;  t = atof(Abuff) ;
printf("%d %d %d  %d\n%f %f  %f  %f\n %f %f %f\n", nva, nvb,
                                              numb_diag, numb_res,
                                              stsum, gt,gt1,low,
                                              up,br,t);
fflush(stdout) ;
/*getch();*/
//printf("\n");
nv=nva+nvb;

if( SymType==C2V ) i=8;
if( SymType==CS  ) i=16;
for(i1=0;i1<nv;i1++)
 {
  i3=16*i1;
  for(i2=0;i2<16;i2++) dimom[16*nv+i2]=0.0;

  for(i2=0;i2<i;i2++)
    {
       fscanf(ccc,"%s",Abuff);
       dimom[i2+i3]=atof(Abuff);
    }
  /*for(i2=0;i2<i;i2++)
     {
       printf("%d  %.2e\n ",i2+i3, dimom[i2+i3]);
     }
  printf("\n"); //getch();
  fflush(stdout) ;*/

 }
fclose(ccc);


//           UPPER STATE PARAMETERS
ccc=fopen(name[2],"rt");




nxu=numb_diag * nv + numb_res*(nv*(nv-1)/2); i=0;
for(i1=0;i1<nxu;i1++){
 if(  fscanf(ccc,"%s",Abuff)>0 )
   {  i++;
 xu[i1]=atof(Abuff);
   }
                 }

printf("\n<par.dat> loaded\n");
fclose(ccc);

/*s0=8/2.6868*3.141592*273.15/t;
s0=s0*(3.141592*3.141592)/3/6.626196/2.997925;
*/
s0=11.18326/stsum*273.15/t;

//if( (eu=new double[SVECSIZE])==NULL) exit(1);
//for(i=0;i<SVECMATRSIZE;i++) if((svecu[i]=new float[SVECSIZE])==NULL) exit(1);

j_old=ju+1;

if( (ccc=fopen("$calc.dat","rb"))!=NULL)
  {
         fread(&j_old,sizeof(int),1, ccc);
         fread(eu,sizeof(double)*SVECMATRSIZE,1, ccc);
         for(i=0;i<SVECMATRSIZE;i++)
         fread(svecu[i],sizeof(float)*SVECSIZE,1, ccc);
         fclose(ccc);
  }

if( ju != j_old )
  { printf(" Calc of upper state ");
    kwan(model,ju, nva,nvb, 1 ,xu,eu,svecu);

              /* 
                    First appealance to KWAN        
                  eigenvalues and eigenvectors      
                      ( _eu and _svecu )            
                   for upper states                 
                 
              */

    j_old=ju;
    if( (ccc=fopen("$calc.dat","wb"))!=NULL)
      {
         fwrite(&j_old,sizeof(int),1, ccc);
         fwrite(eu,sizeof(double)*SVECMATRSIZE,1, ccc);
         for(i=0;i<SVECMATRSIZE;i++)
         fwrite(svecu[i],sizeof(float)*SVECSIZE,1, ccc);
         fclose(ccc);
      }
    else
      {  printf("Error writing output file '$calc.dat' \n");
         //getch();
      }
   }

ccc=fopen("levels.dat","wt");

for(i=0;i<nv;i++)  // i = vib_state_number
 {
 fprintf(ccc,"v=%2d\n",i+1);
 for(tayu=-ju;tayu<=ju;tayu++)
   {
for(i1=0; i1<120; i1++) au[i1]=svecu[(2*ju+1)*(i)+ju+tayu/*+1*/][i1];

ecu=eu[(2*ju+1)*(i)+ju+tayu];
                            /* ecu is calculated energy of upper level*/

jtau_to_jkakc(ju,tayu,&kau,&kcu);
sprintf(upper,"%2d%3d%3d",ju,kau,kcu);
fprintf(ccc,"%s   %12.5f\n",upper,ecu);

   }
  }
fclose(ccc);




ccc=fopen("dif.tmp","wt");






//if( (e0=new double[SVECMATRSIZE])==NULL) exit(1);
//for(i=0;i<SVECMATRSIZE;i++) if((svecl[i]=new float[SVECSIZE])==NULL) exit(1);

FILE *fp;

fp=fopen("calc.res","wt");
fprintf(fp,"v=%d\n",Iv);

for(tayu=-ju;tayu<=ju;tayu++)
   {

for(i1=0; i1<120; i1++) au[i1]=svecu[(2*ju+1)*(Iv-1)+ju+tayu/*+1*/][i1];

ecu=eu[(2*ju+1)*(Iv-1)+ju+tayu];
                            /* ecl is calculated energy of upper level*/

jtau_to_jkakc(ju,tayu,&kau,&kcu);
sprintf(upper,"%2d%3d%3d",ju,kau,kcu);
printf("\n%2d     %s  %f  ",Iv,upper,ecu);
fprintf(fp,"%s  %13.5f\n",upper,ecu);
//for(i1=0;i1<=20;i1++){ printf(" %10.5f\n",eu[i1]);getch();}

ncd=0;

for(jl=ju-1;jl<=ju+1;jl++) {

if(jl<0) goto l10;

              /* 
                    Second appealance to KWAN       
                  eigenvalues and eigenvectors      
                     ( _el and _svecl )             
                   for lower states                 
                 
              */

kwan( 1 ,jl, /*nvaa, nvbb,*/  1, 0  , 1 ,x0,e0,svecl);


for(tayl=-jl;tayl<=jl;tayl++) {            /*  tayl */

for(i1=0;i1<=19;i1++)
     al[i1]=svecl[jl+tayl/*+1*/][i1];

ecl=e0[jl+tayl];            /* ecl is calculated energy of lower level*/
n1=ju+tayu+1;kau=(int)(n1*0.5+0.01);kcu=kau-tayu;
n2=jl+tayl+1;kal=(int)(n2*0.5+0.01);kcl=kal-tayl;
dka=abs(kau-kal);dkc=abs(kcu-kcl);


if( SymType==C2V )
 {
 if( (dka==2*(int)(dka*0.5+0.01)) &&
 (dkc+1==2*(int)((dkc+1)*0.5+0.01)) && (Iv<=nvb)) goto l11;

 if( (dka+1==2*(int)((dka+1)*0.5+0.01)) &&
 (dkc+1==2*(int)((dkc+1)*0.5+0.01)) && (Iv>nvb)) goto l11;
 }

if( SymType==CS )
 {
 if( (dka==2*(int)(dka*0.5+0.01)) &&
 (dkc+1==2*(int)((dkc+1)*0.5+0.01))  )  goto l11;
 if( (dka+1==2*(int)((dka+1)*0.5+0.01)) &&
 (dkc+1==2*(int)((dkc+1)*0.5+0.01))  )  goto l11;
//getch();
 }



goto l12;

l11:   nu=ecu-ecl;

if( (abs(tayu-tayl)>10) || (nu<0.0)) goto l12;
//if( (nu<low) || (nu>up) ) goto l12;

//for(i1=0;i1<=10;i1++) {
//printf("au=%10f   al=%10f\n",au[i1],al[i1]);
//                       };




trmom=dipm(jl,tayl,ju,tayu,Iv, nva,nvb /*nna,nnb*/ ,al,au,dimom, SymType);    /* dipm  */
//printf("trmom=%e\n",trmom);getch();

/* 
      DIPM                   
       */
s2=-1.438833*ecl/t;
s1=-1.438833*nu/t;
s2=exp(s2); s1=1-exp(s1);

i1=abs(tayl);
if( i1==2*(int)(i1*0.5+0.01) ) s3=gt; else s3=gt1;

/*slu=s0*s1*s2*s3*trmom/stsum*nu; */ /*printf("slu=%f\n",slu);*/
slu=s0*s1*s2*s3*trmom*nu;
//printf("   %e\n",trmom);
if( slu<mins ) goto l12; /* mins is minim.intens.of calc line to be find */

/*qjl[ncd]=jl;qtl[ncd]=tayl;*/
jtau_to_jkakc(jl,tayl,&kal,&kcl);

/*printf("LOW LEV   J tau  %d  %d     ka kc   %d  %d ",jl,tayl,kal,kcl);*/

sprintf(ground[ncd],"%2d%3d%3d",jl,kal,kcl);
nucalc[ncd]=nu;scalc[ncd]=slu;eclow[ncd]=ecl;

ncd=ncd+1;
l12:; };      /*jl*/
l10:; };  /*v taul*/

printf("   %d    lines", ncd ) ;
number_of_levels=2*ju+1;
/*
//fwrite(state_cont,sizeof(state_cont),1,ccc);
fwrite(upper,sizeof(upper),1,ccc);
//fwrite(&number_of_levels,sizeof( number_of_levels),1,ccc);
fwrite(&ecu,  sizeof(double)   , 1, ccc);
fwrite(&ncd,  sizeof(  ncd )   , 1, ccc);
fwrite(ground,  sizeof(ground)   , 1, ccc);
fwrite(nucalc,sizeof(nucalc), 1, ccc);
fwrite(scalc, sizeof(scalc) , 1, ccc);
fwrite(eclow, sizeof(eclow) , 1, ccc);
*/
fprintf(ccc,"%s\n",upper);
fprintf(ccc,"%.6f   %d\n",ecu,ncd);
int i0;
for(i0=0;i0<ncd;i0++) {
 fprintf(ccc,"%s\n%.6f   %.6f   %.6e\n",
    ground[i0],eclow[i0],nucalc[i0],scalc[i0]);
                      }
  }
   // tayu


fclose(ccc);

//delete( eu );
//for(i=0;i<SVECMATRSIZE;i++) delete(svecu[i]);


//delete( e0 );
//for(i=0;i<SVECMATRSIZE;i++) delete(svecl[i]);

//free(dimom);

fclose(fp);
return 0;
}


